/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the AccountBaseProperties class.
 * @constructor
 * The properties of a Batch account.
 * @member {object} [autoStorage] The properties related to auto storage.
 * 
 * @member {string} [autoStorage.storageAccountId] The resource id of the
 * storage account to be used for auto storage.
 * 
 */
function AccountBaseProperties() {
}

/**
 * Defines the metadata of AccountBaseProperties
 *
 * @returns {object} metadata of AccountBaseProperties
 *
 */
AccountBaseProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AccountBaseProperties',
    type: {
      name: 'Composite',
      className: 'AccountBaseProperties',
      modelProperties: {
        autoStorage: {
          required: false,
          serializedName: 'autoStorage',
          type: {
            name: 'Composite',
            className: 'AutoStorageBaseProperties'
          }
        }
      }
    }
  };
};

module.exports = AccountBaseProperties;
