/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the AddApplicationPackageResult class.
 * @constructor
 * Response to an ApplicationOperations.AddApplicationPackage request.
 * @member {string} [id] The id of the application.
 * 
 * @member {string} [version] The version of the application.
 * 
 * @member {string} [storageUrl] The URL to which the application package
 * binary file should be uploaded.
 * 
 * @member {date} [storageUrlExpiry] The UTC time at which the storage URL
 * will expire.
 * 
 */
function AddApplicationPackageResult() {
}

/**
 * Defines the metadata of AddApplicationPackageResult
 *
 * @returns {object} metadata of AddApplicationPackageResult
 *
 */
AddApplicationPackageResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AddApplicationPackageResult',
    type: {
      name: 'Composite',
      className: 'AddApplicationPackageResult',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        },
        storageUrl: {
          required: false,
          serializedName: 'storageUrl',
          type: {
            name: 'String'
          }
        },
        storageUrlExpiry: {
          required: false,
          serializedName: 'storageUrlExpiry',
          type: {
            name: 'DateTime'
          }
        }
      }
    }
  };
};

module.exports = AddApplicationPackageResult;
