/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ApplicationPackage class.
 * @constructor
 * Contains information about an application package.
 * @member {string} [version] The version of the application package.
 * 
 * @member {string} [state] The current state of the application package.
 * Possible values include: 'pending', 'active', 'unmapped'
 * 
 * @member {string} [format] The format of the application package, if the
 * package has been activated.
 * 
 * @member {date} [lastActivationTime] The time at which the package was last
 * activated, if the package is active.
 * 
 */
function ApplicationPackage() {
}

/**
 * Defines the metadata of ApplicationPackage
 *
 * @returns {object} metadata of ApplicationPackage
 *
 */
ApplicationPackage.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApplicationPackage',
    type: {
      name: 'Composite',
      className: 'ApplicationPackage',
      modelProperties: {
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        },
        state: {
          required: false,
          serializedName: 'state',
          type: {
            name: 'Enum',
            allowedValues: [ 'pending', 'active', 'unmapped' ]
          }
        },
        format: {
          required: false,
          serializedName: 'format',
          type: {
            name: 'String'
          }
        },
        lastActivationTime: {
          required: false,
          serializedName: 'lastActivationTime',
          type: {
            name: 'DateTime'
          }
        }
      }
    }
  };
};

module.exports = ApplicationPackage;
