/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the AutoStorageProperties class.
 * @constructor
 * Contains information about the auto storage account associated with a Batch
 * account.
 * @member {string} storageAccountId The resource id of the storage account to
 * be used for auto storage account.
 * 
 * @member {date} lastKeySync The UTC time at which storage keys were last
 * synchronized with the Batch account.
 * 
 */
function AutoStorageProperties() {
}

/**
 * Defines the metadata of AutoStorageProperties
 *
 * @returns {object} metadata of AutoStorageProperties
 *
 */
AutoStorageProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AutoStorageProperties',
    type: {
      name: 'Composite',
      className: 'AutoStorageProperties',
      modelProperties: {
        storageAccountId: {
          required: true,
          serializedName: 'storageAccountId',
          type: {
            name: 'String'
          }
        },
        lastKeySync: {
          required: true,
          serializedName: 'lastKeySync',
          type: {
            name: 'DateTime'
          }
        }
      }
    }
  };
};

module.exports = AutoStorageProperties;
