/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the BatchAccountListResult class.
 * @constructor
 * Values returned by the List operation.
 * @member {array} [value] The collection of returned account resources.
 * 
 * @member {string} [nextLink] The continuation token.
 * 
 */
function BatchAccountListResult() {
}

util.inherits(BatchAccountListResult, Array);

/**
 * Defines the metadata of BatchAccountListResult
 *
 * @returns {object} metadata of BatchAccountListResult
 *
 */
BatchAccountListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'BatchAccountListResult',
    type: {
      name: 'Composite',
      className: 'BatchAccountListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'AccountResourceElementType',
                type: {
                  name: 'Composite',
                  className: 'AccountResource'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = BatchAccountListResult;
