/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the GetApplicationPackageResult class.
 * @constructor
 * Response to an ApplicationOperations.GetApplicationPackage request.
 * @member {string} [id] The id of the application.
 * 
 * @member {string} [version] The version of the application package.
 * 
 * @member {string} [state] The current state of the application package.
 * Possible values include: 'pending', 'active', 'unmapped'
 * 
 * @member {string} [format] The format of the application package, if the
 * package is active.
 * 
 * @member {string} [storageUrl] The storage URL at which the application
 * package is stored.
 * 
 * @member {date} [storageUrlExpiry] The UTC time at which the storage URL
 * will expire.
 * 
 * @member {date} [lastActivationTime] The time at which the package was last
 * activated, if the package is active.
 * 
 */
function GetApplicationPackageResult() {
}

/**
 * Defines the metadata of GetApplicationPackageResult
 *
 * @returns {object} metadata of GetApplicationPackageResult
 *
 */
GetApplicationPackageResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'GetApplicationPackageResult',
    type: {
      name: 'Composite',
      className: 'GetApplicationPackageResult',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        },
        state: {
          required: false,
          serializedName: 'state',
          type: {
            name: 'Enum',
            allowedValues: [ 'pending', 'active', 'unmapped' ]
          }
        },
        format: {
          required: false,
          serializedName: 'format',
          type: {
            name: 'String'
          }
        },
        storageUrl: {
          required: false,
          serializedName: 'storageUrl',
          type: {
            name: 'String'
          }
        },
        storageUrlExpiry: {
          required: false,
          serializedName: 'storageUrlExpiry',
          type: {
            name: 'DateTime'
          }
        },
        lastActivationTime: {
          required: false,
          serializedName: 'lastActivationTime',
          type: {
            name: 'DateTime'
          }
        }
      }
    }
  };
};

module.exports = GetApplicationPackageResult;
