/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the CheckNameAvailabilityInput class.
 * @constructor
 * Input of CheckNameAvailability API.
 * @member {string} name The resource name to validate.
 * 
 * @member {string} type The type of the resource whose name is to be
 * validated. Possible values include: 'Microsoft.Cdn/Profiles/Endpoints'
 * 
 */
function CheckNameAvailabilityInput() {
}

/**
 * Defines the metadata of CheckNameAvailabilityInput
 *
 * @returns {object} metadata of CheckNameAvailabilityInput
 *
 */
CheckNameAvailabilityInput.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CheckNameAvailabilityInput',
    type: {
      name: 'Composite',
      className: 'CheckNameAvailabilityInput',
      modelProperties: {
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: true,
          serializedName: 'type',
          type: {
            name: 'Enum',
            allowedValues: [ 'Microsoft.Cdn/Profiles/Endpoints' ]
          }
        }
      }
    }
  };
};

module.exports = CheckNameAvailabilityInput;
