/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the CheckNameAvailabilityOutput class.
 * @constructor
 * Output of check name availability API.
 * @member {boolean} [nameAvailable] Indicates whether the name is available.
 * 
 * @member {string} [reason] The reason why the name is not available.
 * 
 * @member {string} [message] The detailed error message describing why the
 * name is not available.
 * 
 */
function CheckNameAvailabilityOutput() {
}

/**
 * Defines the metadata of CheckNameAvailabilityOutput
 *
 * @returns {object} metadata of CheckNameAvailabilityOutput
 *
 */
CheckNameAvailabilityOutput.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CheckNameAvailabilityOutput',
    type: {
      name: 'Composite',
      className: 'CheckNameAvailabilityOutput',
      modelProperties: {
        nameAvailable: {
          required: false,
          serializedName: 'NameAvailable',
          type: {
            name: 'Boolean'
          }
        },
        reason: {
          required: false,
          serializedName: 'Reason',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          serializedName: 'Message',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CheckNameAvailabilityOutput;
