/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the CustomDomainParameters class.
 * @constructor
 * CustomDomain properties required for custom domain creation or update.
 * @member {string} hostName The host name of the custom domain. Must be a
 * domain name.
 * 
 */
function CustomDomainParameters() {
  CustomDomainParameters['super_'].call(this);
}

util.inherits(CustomDomainParameters, models['BaseResource']);

/**
 * Defines the metadata of CustomDomainParameters
 *
 * @returns {object} metadata of CustomDomainParameters
 *
 */
CustomDomainParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CustomDomainParameters',
    type: {
      name: 'Composite',
      className: 'CustomDomainParameters',
      modelProperties: {
        hostName: {
          required: true,
          serializedName: 'properties.hostName',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CustomDomainParameters;
