/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ProfileCreateParameters class.
 * @constructor
 * Profile properties required for profile creation.
 * @member {string} location Profile location
 * 
 * @member {object} [tags] Profile tags
 * 
 * @member {object} sku The SKU (pricing tier) of the CDN profile.
 * 
 * @member {string} [sku.name] Name of the pricing tier. Possible values
 * include: 'Standard_Verizon', 'Premium_Verizon', 'Custom_Verizon',
 * 'Standard_Akamai'
 * 
 */
function ProfileCreateParameters() {
  ProfileCreateParameters['super_'].call(this);
}

util.inherits(ProfileCreateParameters, models['BaseResource']);

/**
 * Defines the metadata of ProfileCreateParameters
 *
 * @returns {object} metadata of ProfileCreateParameters
 *
 */
ProfileCreateParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ProfileCreateParameters',
    type: {
      name: 'Composite',
      className: 'ProfileCreateParameters',
      modelProperties: {
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        sku: {
          required: true,
          serializedName: 'sku',
          type: {
            name: 'Composite',
            className: 'Sku'
          }
        }
      }
    }
  };
};

module.exports = ProfileCreateParameters;
