/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Resource class.
 * @constructor
 * @member {string} [id] Resource ID
 * 
 * @member {string} [name] Resource name
 * 
 * @member {string} [type] Resource type
 * 
 */
function Resource() {
  Resource['super_'].call(this);
}

util.inherits(Resource, models['BaseResource']);

/**
 * Defines the metadata of Resource
 *
 * @returns {object} metadata of Resource
 *
 */
Resource.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Resource',
    type: {
      name: 'Composite',
      className: 'Resource',
      modelProperties: {
        id: {
          required: false,
          readOnly: true,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          readOnly: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          readOnly: true,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = Resource;
