/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Sku class.
 * @constructor
 * The SKU (pricing tier) of the CDN profile.
 * @member {string} [name] Name of the pricing tier. Possible values include:
 * 'Standard_Verizon', 'Premium_Verizon', 'Custom_Verizon', 'Standard_Akamai'
 * 
 */
function Sku() {
}

/**
 * Defines the metadata of Sku
 *
 * @returns {object} metadata of Sku
 *
 */
Sku.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Sku',
    type: {
      name: 'Composite',
      className: 'Sku',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'Enum',
            allowedValues: [ 'Standard_Verizon', 'Premium_Verizon', 'Custom_Verizon', 'Standard_Akamai' ]
          }
        }
      }
    }
  };
};

module.exports = Sku;
