/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the TrackedResource class.
 * @constructor
 * ARM tracked resource
 * @member {string} location Resource location
 * 
 * @member {object} tags Resource tags
 * 
 */
function TrackedResource() {
  TrackedResource['super_'].call(this);
}

util.inherits(TrackedResource, models['Resource']);

/**
 * Defines the metadata of TrackedResource
 *
 * @returns {object} metadata of TrackedResource
 *
 */
TrackedResource.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TrackedResource',
    type: {
      name: 'Composite',
      className: 'TrackedResource',
      modelProperties: {
        id: {
          required: false,
          readOnly: true,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          readOnly: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          readOnly: true,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: true,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = TrackedResource;
