/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ValidateCustomDomainOutput class.
 * @constructor
 * Output of custom domain validation.
 * @member {boolean} [customDomainValidated] Indicates whether the custom
 * domain is validated or not.
 * 
 * @member {string} [reason] The reason why the custom domain is not valid.
 * 
 * @member {string} [message] The message describing why the custom domain is
 * not valid.
 * 
 */
function ValidateCustomDomainOutput() {
}

/**
 * Defines the metadata of ValidateCustomDomainOutput
 *
 * @returns {object} metadata of ValidateCustomDomainOutput
 *
 */
ValidateCustomDomainOutput.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ValidateCustomDomainOutput',
    type: {
      name: 'Composite',
      className: 'ValidateCustomDomainOutput',
      modelProperties: {
        customDomainValidated: {
          required: false,
          serializedName: 'customDomainValidated',
          type: {
            name: 'Boolean'
          }
        },
        reason: {
          required: false,
          serializedName: 'reason',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ValidateCustomDomainOutput;
