/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the AdditionalUnattendContent class.
 * @constructor
 * additional XML formatted information that can be included in the
 * Unattend.xml file, which is used by Windows Setup. Contents are defined by
 * setting name, component name, and the pass in which the content is a
 * applied.
 * @member {string} [passName] the pass name. Currently, the only allowable
 * value is oobeSystem. Possible values include: 'oobeSystem'
 * 
 * @member {string} [componentName] the component name. Currently, the only
 * allowable value is Microsoft-Windows-Shell-Setup. Possible values include:
 * 'Microsoft-Windows-Shell-Setup'
 * 
 * @member {string} [settingName] setting name (e.g. FirstLogonCommands,
 * AutoLogon ). Possible values include: 'AutoLogon', 'FirstLogonCommands'
 * 
 * @member {string} [content] XML formatted content that is added to the
 * unattend.xml file in the specified pass and component.The XML must be less
 * than 4 KB and must include the root element for the setting or feature
 * that is being inserted.
 * 
 */
function AdditionalUnattendContent() {
}

/**
 * Defines the metadata of AdditionalUnattendContent
 *
 * @returns {object} metadata of AdditionalUnattendContent
 *
 */
AdditionalUnattendContent.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AdditionalUnattendContent',
    type: {
      name: 'Composite',
      className: 'AdditionalUnattendContent',
      modelProperties: {
        passName: {
          required: false,
          serializedName: 'passName',
          type: {
            name: 'Enum',
            allowedValues: [ 'oobeSystem' ]
          }
        },
        componentName: {
          required: false,
          serializedName: 'componentName',
          type: {
            name: 'Enum',
            allowedValues: [ 'Microsoft-Windows-Shell-Setup' ]
          }
        },
        settingName: {
          required: false,
          serializedName: 'settingName',
          type: {
            name: 'Enum',
            allowedValues: [ 'AutoLogon', 'FirstLogonCommands' ]
          }
        },
        content: {
          required: false,
          serializedName: 'content',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AdditionalUnattendContent;
