/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ApiError class.
 * @constructor
 * Api error.
 * @member {array} [details] the Api error details
 * 
 * @member {object} [innererror] the Api inner error
 * 
 * @member {string} [innererror.exceptiontype] the exception type.
 * 
 * @member {string} [innererror.errordetail] the internal error message or
 * exception dump.
 * 
 * @member {string} [code] the error code.
 * 
 * @member {string} [target] the target of the particular error.
 * 
 * @member {string} [message] the error message.
 * 
 */
function ApiError() {
}

/**
 * Defines the metadata of ApiError
 *
 * @returns {object} metadata of ApiError
 *
 */
ApiError.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApiError',
    type: {
      name: 'Composite',
      className: 'ApiError',
      modelProperties: {
        details: {
          required: false,
          serializedName: 'details',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ApiErrorBaseElementType',
                type: {
                  name: 'Composite',
                  className: 'ApiErrorBase'
                }
            }
          }
        },
        innererror: {
          required: false,
          serializedName: 'innererror',
          type: {
            name: 'Composite',
            className: 'InnerError'
          }
        },
        code: {
          required: false,
          serializedName: 'code',
          type: {
            name: 'String'
          }
        },
        target: {
          required: false,
          serializedName: 'target',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ApiError;
