/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the BootDiagnosticsInstanceView class.
 * @constructor
 * The instance view of a virtual machine boot diagnostics.
 * @member {string} [consoleScreenshotBlobUri] the console screenshot blob Uri.
 * 
 * @member {string} [serialConsoleLogBlobUri] the Linux serial console log
 * blob Uri.
 * 
 */
function BootDiagnosticsInstanceView() {
}

/**
 * Defines the metadata of BootDiagnosticsInstanceView
 *
 * @returns {object} metadata of BootDiagnosticsInstanceView
 *
 */
BootDiagnosticsInstanceView.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'BootDiagnosticsInstanceView',
    type: {
      name: 'Composite',
      className: 'BootDiagnosticsInstanceView',
      modelProperties: {
        consoleScreenshotBlobUri: {
          required: false,
          serializedName: 'consoleScreenshotBlobUri',
          type: {
            name: 'String'
          }
        },
        serialConsoleLogBlobUri: {
          required: false,
          serializedName: 'serialConsoleLogBlobUri',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = BootDiagnosticsInstanceView;
