/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the ContainerServiceDiagnosticsProfile class.
 * @constructor
 * @member {object} [vmDiagnostics] Profile for container service VM
 * diagnostic agent
 * 
 * @member {boolean} [vmDiagnostics.enabled] whether VM Diagnostic Agent
 * should be provisioned on the Virtual Machine.
 * 
 * @member {string} [vmDiagnostics.storageUri] whether VM Diagnostic Agent
 * should be provisioned on the Virtual Machine.
 * 
 */
function ContainerServiceDiagnosticsProfile() {
}

/**
 * Defines the metadata of ContainerServiceDiagnosticsProfile
 *
 * @returns {object} metadata of ContainerServiceDiagnosticsProfile
 *
 */
ContainerServiceDiagnosticsProfile.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ContainerServiceDiagnosticsProfile',
    type: {
      name: 'Composite',
      className: 'ContainerServiceDiagnosticsProfile',
      modelProperties: {
        vmDiagnostics: {
          required: false,
          serializedName: 'vmDiagnostics',
          type: {
            name: 'Composite',
            className: 'ContainerServiceVMDiagnostics'
          }
        }
      }
    }
  };
};

module.exports = ContainerServiceDiagnosticsProfile;
