/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the ContainerServiceLinuxProfile class.
 * @constructor
 * Profile for Linux VMs
 * @member {string} adminUsername The administrator username to use for all
 * Linux VMs
 * 
 * @member {object} ssh Specifies the ssh key configuration for Linux VMs
 * 
 * @member {array} [ssh.publicKeys] the list of SSH public keys used to
 * authenticate with Linux based VMs
 * 
 */
function ContainerServiceLinuxProfile() {
}

/**
 * Defines the metadata of ContainerServiceLinuxProfile
 *
 * @returns {object} metadata of ContainerServiceLinuxProfile
 *
 */
ContainerServiceLinuxProfile.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ContainerServiceLinuxProfile',
    type: {
      name: 'Composite',
      className: 'ContainerServiceLinuxProfile',
      modelProperties: {
        adminUsername: {
          required: true,
          serializedName: 'adminUsername',
          type: {
            name: 'String'
          }
        },
        ssh: {
          required: true,
          serializedName: 'ssh',
          type: {
            name: 'Composite',
            className: 'ContainerServiceSshConfiguration'
          }
        }
      }
    }
  };
};

module.exports = ContainerServiceLinuxProfile;
