/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ContainerServiceOrchestratorProfile class.
 * @constructor
 * Profile for Orchestrator
 * @member {string} [orchestratorType] Specifies what orchestrator will be
 * used to manage container cluster resources. Possible values include:
 * 'Swarm', 'DCOS'
 * 
 */
function ContainerServiceOrchestratorProfile() {
}

/**
 * Defines the metadata of ContainerServiceOrchestratorProfile
 *
 * @returns {object} metadata of ContainerServiceOrchestratorProfile
 *
 */
ContainerServiceOrchestratorProfile.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ContainerServiceOrchestratorProfile',
    type: {
      name: 'Composite',
      className: 'ContainerServiceOrchestratorProfile',
      modelProperties: {
        orchestratorType: {
          required: false,
          serializedName: 'orchestratorType',
          type: {
            name: 'Enum',
            allowedValues: [ 'Swarm', 'DCOS' ]
          }
        }
      }
    }
  };
};

module.exports = ContainerServiceOrchestratorProfile;
