/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ContainerServiceSshConfiguration class.
 * @constructor
 * SSH configuration for Linux based VMs running on Azure
 * @member {array} [publicKeys] the list of SSH public keys used to
 * authenticate with Linux based VMs
 * 
 */
function ContainerServiceSshConfiguration() {
}

/**
 * Defines the metadata of ContainerServiceSshConfiguration
 *
 * @returns {object} metadata of ContainerServiceSshConfiguration
 *
 */
ContainerServiceSshConfiguration.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ContainerServiceSshConfiguration',
    type: {
      name: 'Composite',
      className: 'ContainerServiceSshConfiguration',
      modelProperties: {
        publicKeys: {
          required: false,
          serializedName: 'publicKeys',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ContainerServiceSshPublicKeyElementType',
                type: {
                  name: 'Composite',
                  className: 'ContainerServiceSshPublicKey'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = ContainerServiceSshConfiguration;
