/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ContainerServiceSshPublicKey class.
 * @constructor
 * Contains information about SSH certificate public key data.
 * @member {string} keyData Certificate public key used to authenticate with
 * VM through SSH. The certificate must be in Pem format with or without
 * headers.
 * 
 */
function ContainerServiceSshPublicKey() {
}

/**
 * Defines the metadata of ContainerServiceSshPublicKey
 *
 * @returns {object} metadata of ContainerServiceSshPublicKey
 *
 */
ContainerServiceSshPublicKey.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ContainerServiceSshPublicKey',
    type: {
      name: 'Composite',
      className: 'ContainerServiceSshPublicKey',
      modelProperties: {
        keyData: {
          required: true,
          serializedName: 'keyData',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ContainerServiceSshPublicKey;
