/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the DataDiskImage class.
 * @constructor
 * Contains the data disk images information.
 * @member {number} [lun] the LUN number for a data disk.This value is used to
 * identify data disk image inside the VMImage therefore it must be unique
 * for each data disk.The allowed character for the value is digit.
 * 
 */
function DataDiskImage() {
}

/**
 * Defines the metadata of DataDiskImage
 *
 * @returns {object} metadata of DataDiskImage
 *
 */
DataDiskImage.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DataDiskImage',
    type: {
      name: 'Composite',
      className: 'DataDiskImage',
      modelProperties: {
        lun: {
          required: false,
          readOnly: true,
          serializedName: 'lun',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = DataDiskImage;
