/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the DeleteOperationResult class.
 * @constructor
 * The compute long running operation response.
 * @member {string} operationId Gets the operation identifier.
 * 
 * @member {string} status Gets the operation status. Possible values include:
 * 'InProgress', 'Succeeded', 'Failed'
 * 
 * @member {date} startTime Gets the operation start time
 * 
 * @member {date} [endTime] Gets the operation end time
 * 
 * @member {object} [error] Gets or sets the operation error if any occurred
 * 
 * @member {array} [error.details] Gets or sets the Api error details
 * 
 * @member {object} [error.innererror] Gets or sets the Api inner error
 * 
 * @member {string} [error.innererror.exceptiontype] Gets or sets the
 * exception type.
 * 
 * @member {string} [error.innererror.errordetail] Gets or sets the internal
 * error message or exception dump.
 * 
 * @member {string} [error.code] Gets or sets the error code.
 * 
 * @member {string} [error.target] Gets or sets the target of the particular
 * error.
 * 
 * @member {string} [error.message] Gets or sets the error message.
 * 
 */
function DeleteOperationResult() {
}

/**
 * Defines the metadata of DeleteOperationResult
 *
 * @returns {object} metadata of DeleteOperationResult
 *
 */
DeleteOperationResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DeleteOperationResult',
    type: {
      name: 'Composite',
      className: 'DeleteOperationResult',
      modelProperties: {
        operationId: {
          required: true,
          serializedName: 'operationId',
          type: {
            name: 'String'
          }
        },
        status: {
          required: true,
          serializedName: 'status',
          type: {
            name: 'Enum',
            allowedValues: [ 'InProgress', 'Succeeded', 'Failed' ]
          }
        },
        startTime: {
          required: true,
          serializedName: 'startTime',
          type: {
            name: 'DateTime'
          }
        },
        endTime: {
          required: false,
          serializedName: 'endTime',
          type: {
            name: 'DateTime'
          }
        },
        error: {
          required: false,
          serializedName: 'error',
          type: {
            name: 'Composite',
            className: 'ApiError'
          }
        }
      }
    }
  };
};

module.exports = DeleteOperationResult;
