/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the DiagnosticsProfile class.
 * @constructor
 * Describes a diagnostics profile.
 * @member {object} [bootDiagnostics] the boot diagnostics.
 * 
 * @member {boolean} [bootDiagnostics.enabled] whether boot diagnostics should
 * be enabled on the Virtual Machine.
 * 
 * @member {string} [bootDiagnostics.storageUri] the boot diagnostics storage
 * Uri. It should be a valid Uri
 * 
 */
function DiagnosticsProfile() {
}

/**
 * Defines the metadata of DiagnosticsProfile
 *
 * @returns {object} metadata of DiagnosticsProfile
 *
 */
DiagnosticsProfile.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DiagnosticsProfile',
    type: {
      name: 'Composite',
      className: 'DiagnosticsProfile',
      modelProperties: {
        bootDiagnostics: {
          required: false,
          serializedName: 'bootDiagnostics',
          type: {
            name: 'Composite',
            className: 'BootDiagnostics'
          }
        }
      }
    }
  };
};

module.exports = DiagnosticsProfile;
