/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the DiskInstanceView class.
 * @constructor
 * The instance view of the disk.
 * @member {string} [name] the disk name.
 * 
 * @member {array} [statuses] the resource status information.
 * 
 */
function DiskInstanceView() {
}

/**
 * Defines the metadata of DiskInstanceView
 *
 * @returns {object} metadata of DiskInstanceView
 *
 */
DiskInstanceView.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DiskInstanceView',
    type: {
      name: 'Composite',
      className: 'DiskInstanceView',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        statuses: {
          required: false,
          serializedName: 'statuses',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'InstanceViewStatusElementType',
                type: {
                  name: 'Composite',
                  className: 'InstanceViewStatus'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = DiskInstanceView;
