/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ImageReference class.
 * @constructor
 * The image reference.
 * @member {string} [publisher] the image publisher.
 * 
 * @member {string} [offer] the image offer.
 * 
 * @member {string} [sku] the image sku.
 * 
 * @member {string} [version] the image version. The allowed formats are
 * Major.Minor.Build or 'latest'. Major, Minor and Build being decimal
 * numbers. Specify 'latest' to use the latest version of image.
 * 
 */
function ImageReference() {
}

/**
 * Defines the metadata of ImageReference
 *
 * @returns {object} metadata of ImageReference
 *
 */
ImageReference.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ImageReference',
    type: {
      name: 'Composite',
      className: 'ImageReference',
      modelProperties: {
        publisher: {
          required: false,
          serializedName: 'publisher',
          type: {
            name: 'String'
          }
        },
        offer: {
          required: false,
          serializedName: 'offer',
          type: {
            name: 'String'
          }
        },
        sku: {
          required: false,
          serializedName: 'sku',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ImageReference;
