/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the KeyVaultKeyReference class.
 * @constructor
 * Describes a reference to Key Vault Key
 * @member {string} keyUrl the URL referencing a key in a Key Vault.
 * 
 * @member {object} sourceVault the Relative URL of the Key Vault containing
 * the key
 * 
 * @member {string} [sourceVault.id] Resource Id
 * 
 */
function KeyVaultKeyReference() {
}

/**
 * Defines the metadata of KeyVaultKeyReference
 *
 * @returns {object} metadata of KeyVaultKeyReference
 *
 */
KeyVaultKeyReference.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'KeyVaultKeyReference',
    type: {
      name: 'Composite',
      className: 'KeyVaultKeyReference',
      modelProperties: {
        keyUrl: {
          required: true,
          serializedName: 'keyUrl',
          type: {
            name: 'String'
          }
        },
        sourceVault: {
          required: true,
          serializedName: 'sourceVault',
          type: {
            name: 'Composite',
            className: 'SubResource'
          }
        }
      }
    }
  };
};

module.exports = KeyVaultKeyReference;
