/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the KeyVaultSecretReference class.
 * @constructor
 * Describes a reference to Key Vault Secret
 * @member {string} secretUrl the URL referencing a secret in a Key Vault.
 * 
 * @member {object} sourceVault the Relative URL of the Key Vault containing
 * the secret.
 * 
 * @member {string} [sourceVault.id] Resource Id
 * 
 */
function KeyVaultSecretReference() {
}

/**
 * Defines the metadata of KeyVaultSecretReference
 *
 * @returns {object} metadata of KeyVaultSecretReference
 *
 */
KeyVaultSecretReference.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'KeyVaultSecretReference',
    type: {
      name: 'Composite',
      className: 'KeyVaultSecretReference',
      modelProperties: {
        secretUrl: {
          required: true,
          serializedName: 'secretUrl',
          type: {
            name: 'String'
          }
        },
        sourceVault: {
          required: true,
          serializedName: 'sourceVault',
          type: {
            name: 'Composite',
            className: 'SubResource'
          }
        }
      }
    }
  };
};

module.exports = KeyVaultSecretReference;
