/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the LinuxConfiguration class.
 * @constructor
 * Describes Windows Configuration of the OS Profile.
 * @member {boolean} [disablePasswordAuthentication] whether Authentication
 * using user name and password is allowed or not
 * 
 * @member {object} [ssh] the SSH configuration for linux VMs
 * 
 * @member {array} [ssh.publicKeys] the list of SSH public keys used to
 * authenticate with linux based VMs
 * 
 */
function LinuxConfiguration() {
}

/**
 * Defines the metadata of LinuxConfiguration
 *
 * @returns {object} metadata of LinuxConfiguration
 *
 */
LinuxConfiguration.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'LinuxConfiguration',
    type: {
      name: 'Composite',
      className: 'LinuxConfiguration',
      modelProperties: {
        disablePasswordAuthentication: {
          required: false,
          serializedName: 'disablePasswordAuthentication',
          type: {
            name: 'Boolean'
          }
        },
        ssh: {
          required: false,
          serializedName: 'ssh',
          type: {
            name: 'Composite',
            className: 'SshConfiguration'
          }
        }
      }
    }
  };
};

module.exports = LinuxConfiguration;
