/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ListUsagesResult class.
 * @constructor
 * The List Usages operation response.
 * @member {array} [value] the list Compute Resource Usages.
 * 
 * @member {string} [nextLink] the uri to fetch the next page of Compute
 * Resource Usages. Call ListNext() with this to fetch the next page of
 * Compute Resource Usages.
 * 
 */
function ListUsagesResult() {
}

util.inherits(ListUsagesResult, Array);

/**
 * Defines the metadata of ListUsagesResult
 *
 * @returns {object} metadata of ListUsagesResult
 *
 */
ListUsagesResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ListUsagesResult',
    type: {
      name: 'Composite',
      className: 'ListUsagesResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'UsageElementType',
                type: {
                  name: 'Composite',
                  className: 'Usage'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ListUsagesResult;
