/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Plan class.
 * @constructor
 * Plan for the resource.
 * @member {string} [name] the plan ID.
 * 
 * @member {string} [publisher] the publisher ID.
 * 
 * @member {string} [product] the offer ID.
 * 
 * @member {string} [promotionCode] the promotion code.
 * 
 */
function Plan() {
}

/**
 * Defines the metadata of Plan
 *
 * @returns {object} metadata of Plan
 *
 */
Plan.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Plan',
    type: {
      name: 'Composite',
      className: 'Plan',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        publisher: {
          required: false,
          serializedName: 'publisher',
          type: {
            name: 'String'
          }
        },
        product: {
          required: false,
          serializedName: 'product',
          type: {
            name: 'String'
          }
        },
        promotionCode: {
          required: false,
          serializedName: 'promotionCode',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = Plan;
