/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the PurchasePlan class.
 * @constructor
 * Used for establishing the purchase context of any 3rd Party artifact
 * through MarketPlace.
 * @member {string} publisher the publisher ID.
 * 
 * @member {string} name the plan ID.
 * 
 * @member {string} product the product ID.
 * 
 */
function PurchasePlan() {
}

/**
 * Defines the metadata of PurchasePlan
 *
 * @returns {object} metadata of PurchasePlan
 *
 */
PurchasePlan.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'PurchasePlan',
    type: {
      name: 'Composite',
      className: 'PurchasePlan',
      modelProperties: {
        publisher: {
          required: true,
          serializedName: 'publisher',
          type: {
            name: 'String'
          }
        },
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        product: {
          required: true,
          serializedName: 'product',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = PurchasePlan;
