/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the SshPublicKey class.
 * @constructor
 * Contains information about SSH certificate public key and the path on the
 * Linux VM where the public key is placed.
 * @member {string} [path] the full path on the created VM where SSH public
 * key is stored. If the file already exists, the specified key is appended
 * to the file.
 * 
 * @member {string} [keyData] Certificate public key used to authenticate with
 * VM through SSH.The certificate must be in Pem format with or without
 * headers.
 * 
 */
function SshPublicKey() {
}

/**
 * Defines the metadata of SshPublicKey
 *
 * @returns {object} metadata of SshPublicKey
 *
 */
SshPublicKey.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SshPublicKey',
    type: {
      name: 'Composite',
      className: 'SshPublicKey',
      modelProperties: {
        path: {
          required: false,
          serializedName: 'path',
          type: {
            name: 'String'
          }
        },
        keyData: {
          required: false,
          serializedName: 'keyData',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = SshPublicKey;
