/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the Usage class.
 * @constructor
 * Describes Compute Resource Usage.
 * @member {number} currentValue the current value of the usage.
 * 
 * @member {number} limit the limit of usage.
 * 
 * @member {object} name the name of the type of usage.
 * 
 * @member {string} [name.value] a string describing the resource name.
 * 
 * @member {string} [name.localizedValue] a localized string describing the
 * resource name.
 * 
 */
function Usage() {
}

/**
 * Defines the metadata of Usage
 *
 * @returns {object} metadata of Usage
 *
 */
Usage.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Usage',
    type: {
      name: 'Composite',
      className: 'Usage',
      modelProperties: {
        unit: {
          required: true,
          isConstant: true,
          serializedName: 'unit',
          defaultValue: 'Count',
          type: {
            name: 'String'
          }
        },
        currentValue: {
          required: true,
          serializedName: 'currentValue',
          type: {
            name: 'Number'
          }
        },
        limit: {
          required: true,
          serializedName: 'limit',
          type: {
            name: 'Number'
          }
        },
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'Composite',
            className: 'UsageName'
          }
        }
      }
    }
  };
};

module.exports = Usage;
