/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualMachineAgentInstanceView class.
 * @constructor
 * The instance view of the VM Agent running on the virtual machine.
 * @member {string} [vmAgentVersion] the VM Agent full version.
 * 
 * @member {array} [extensionHandlers] the virtual machine extension handler
 * instance view.
 * 
 * @member {array} [statuses] the resource status information.
 * 
 */
function VirtualMachineAgentInstanceView() {
}

/**
 * Defines the metadata of VirtualMachineAgentInstanceView
 *
 * @returns {object} metadata of VirtualMachineAgentInstanceView
 *
 */
VirtualMachineAgentInstanceView.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineAgentInstanceView',
    type: {
      name: 'Composite',
      className: 'VirtualMachineAgentInstanceView',
      modelProperties: {
        vmAgentVersion: {
          required: false,
          serializedName: 'vmAgentVersion',
          type: {
            name: 'String'
          }
        },
        extensionHandlers: {
          required: false,
          serializedName: 'extensionHandlers',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'VirtualMachineExtensionHandlerInstanceViewElementType',
                type: {
                  name: 'Composite',
                  className: 'VirtualMachineExtensionHandlerInstanceView'
                }
            }
          }
        },
        statuses: {
          required: false,
          serializedName: 'statuses',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'InstanceViewStatusElementType',
                type: {
                  name: 'Composite',
                  className: 'InstanceViewStatus'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineAgentInstanceView;
