/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the VirtualMachineCaptureParameters class.
 * @constructor
 * Capture Virtual Machine parameters.
 * @member {string} vhdPrefix the captured VirtualHardDisk's name prefix.
 * 
 * @member {string} destinationContainerName the destination container name.
 * 
 * @member {boolean} overwriteVhds whether it overwrites destination
 * VirtualHardDisk if true, in case of conflict.
 * 
 */
function VirtualMachineCaptureParameters() {
}

/**
 * Defines the metadata of VirtualMachineCaptureParameters
 *
 * @returns {object} metadata of VirtualMachineCaptureParameters
 *
 */
VirtualMachineCaptureParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineCaptureParameters',
    type: {
      name: 'Composite',
      className: 'VirtualMachineCaptureParameters',
      modelProperties: {
        vhdPrefix: {
          required: true,
          serializedName: 'vhdPrefix',
          type: {
            name: 'String'
          }
        },
        destinationContainerName: {
          required: true,
          serializedName: 'destinationContainerName',
          type: {
            name: 'String'
          }
        },
        overwriteVhds: {
          required: true,
          serializedName: 'overwriteVhds',
          type: {
            name: 'Boolean'
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineCaptureParameters;
