/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the VirtualMachineExtensionHandlerInstanceView class.
 * @constructor
 * The instance view of a virtual machine extension handler.
 * @member {string} [type] full type of the extension handler which includes
 * both publisher and type.
 * 
 * @member {string} [typeHandlerVersion] the type version of the extension
 * handler.
 * 
 * @member {object} [status] the extension handler status.
 * 
 * @member {string} [status.code] the status Code.
 * 
 * @member {string} [status.level] the level Code. Possible values include:
 * 'Info', 'Warning', 'Error'
 * 
 * @member {string} [status.displayStatus] the short localizable label for the
 * status.
 * 
 * @member {string} [status.message] the detailed Message, including for
 * alerts and error messages.
 * 
 * @member {date} [status.time] the time of the status.
 * 
 */
function VirtualMachineExtensionHandlerInstanceView() {
}

/**
 * Defines the metadata of VirtualMachineExtensionHandlerInstanceView
 *
 * @returns {object} metadata of VirtualMachineExtensionHandlerInstanceView
 *
 */
VirtualMachineExtensionHandlerInstanceView.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineExtensionHandlerInstanceView',
    type: {
      name: 'Composite',
      className: 'VirtualMachineExtensionHandlerInstanceView',
      modelProperties: {
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        typeHandlerVersion: {
          required: false,
          serializedName: 'typeHandlerVersion',
          type: {
            name: 'String'
          }
        },
        status: {
          required: false,
          serializedName: 'status',
          type: {
            name: 'Composite',
            className: 'InstanceViewStatus'
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineExtensionHandlerInstanceView;
