/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualMachineExtensionInstanceView class.
 * @constructor
 * The instance view of a virtual machine extension.
 * @member {string} [name] the virtual machine extension name.
 * 
 * @member {string} [type] the full type of the extension handler which
 * includes both publisher and type.
 * 
 * @member {string} [typeHandlerVersion] the type version of the extension
 * handler.
 * 
 * @member {array} [substatuses] the resource status information.
 * 
 * @member {array} [statuses] the resource status information.
 * 
 */
function VirtualMachineExtensionInstanceView() {
}

/**
 * Defines the metadata of VirtualMachineExtensionInstanceView
 *
 * @returns {object} metadata of VirtualMachineExtensionInstanceView
 *
 */
VirtualMachineExtensionInstanceView.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineExtensionInstanceView',
    type: {
      name: 'Composite',
      className: 'VirtualMachineExtensionInstanceView',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        typeHandlerVersion: {
          required: false,
          serializedName: 'typeHandlerVersion',
          type: {
            name: 'String'
          }
        },
        substatuses: {
          required: false,
          serializedName: 'substatuses',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'InstanceViewStatusElementType',
                type: {
                  name: 'Composite',
                  className: 'InstanceViewStatus'
                }
            }
          }
        },
        statuses: {
          required: false,
          serializedName: 'statuses',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'InstanceViewStatusElementType',
                type: {
                  name: 'Composite',
                  className: 'InstanceViewStatus'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineExtensionInstanceView;
