/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualMachineListResult class.
 * @constructor
 * The List Virtual Machine operation response.
 * @member {array} [value] the list of virtual machines.
 * 
 * @member {string} [nextLink] the uri to fetch the next page of VMs. Call
 * ListNext() with this to fetch the next page of Virtual Machines.
 * 
 */
function VirtualMachineListResult() {
}

util.inherits(VirtualMachineListResult, Array);

/**
 * Defines the metadata of VirtualMachineListResult
 *
 * @returns {object} metadata of VirtualMachineListResult
 *
 */
VirtualMachineListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineListResult',
    type: {
      name: 'Composite',
      className: 'VirtualMachineListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'VirtualMachineElementType',
                type: {
                  name: 'Composite',
                  className: 'VirtualMachine'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineListResult;
