/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualMachineScaleSetExtensionProfile class.
 * @constructor
 * Describes a virtual machine scale set extension profile.
 * @member {array} [extensions] the virtual machine scale set child extension
 * resources.
 * 
 */
function VirtualMachineScaleSetExtensionProfile() {
}

/**
 * Defines the metadata of VirtualMachineScaleSetExtensionProfile
 *
 * @returns {object} metadata of VirtualMachineScaleSetExtensionProfile
 *
 */
VirtualMachineScaleSetExtensionProfile.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineScaleSetExtensionProfile',
    type: {
      name: 'Composite',
      className: 'VirtualMachineScaleSetExtensionProfile',
      modelProperties: {
        extensions: {
          required: false,
          serializedName: 'extensions',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'VirtualMachineScaleSetExtensionElementType',
                type: {
                  name: 'Composite',
                  className: 'VirtualMachineScaleSetExtension'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineScaleSetExtensionProfile;
