/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the VirtualMachineScaleSetSku class.
 * @constructor
 * Describes an available virtual machine scale set sku.
 * @member {string} [resourceType] the type of resource the sku applies to.
 * 
 * @member {object} [sku] the Sku.
 * 
 * @member {string} [sku.name] the sku name.
 * 
 * @member {string} [sku.tier] the sku tier.
 * 
 * @member {number} [sku.capacity] the sku capacity.
 * 
 * @member {object} [capacity] available scaling information.
 * 
 * @member {number} [capacity.minimum] the minimum capacity.
 * 
 * @member {number} [capacity.maximum] the maximum capacity that can be set.
 * 
 * @member {number} [capacity.defaultCapacity] the default capacity.
 * 
 * @member {string} [capacity.scaleType] the scale type applicable to the sku.
 * Possible values include: 'Automatic', 'None'
 * 
 */
function VirtualMachineScaleSetSku() {
}

/**
 * Defines the metadata of VirtualMachineScaleSetSku
 *
 * @returns {object} metadata of VirtualMachineScaleSetSku
 *
 */
VirtualMachineScaleSetSku.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineScaleSetSku',
    type: {
      name: 'Composite',
      className: 'VirtualMachineScaleSetSku',
      modelProperties: {
        resourceType: {
          required: false,
          readOnly: true,
          serializedName: 'resourceType',
          type: {
            name: 'String'
          }
        },
        sku: {
          required: false,
          readOnly: true,
          serializedName: 'sku',
          type: {
            name: 'Composite',
            className: 'Sku'
          }
        },
        capacity: {
          required: false,
          readOnly: true,
          serializedName: 'capacity',
          type: {
            name: 'Composite',
            className: 'VirtualMachineScaleSetSkuCapacity'
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineScaleSetSku;
