/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the VirtualMachineScaleSetSkuCapacity class.
 * @constructor
 * Describes scaling information of a sku.
 * @member {number} [minimum] the minimum capacity.
 * 
 * @member {number} [maximum] the maximum capacity that can be set.
 * 
 * @member {number} [defaultCapacity] the default capacity.
 * 
 * @member {string} [scaleType] the scale type applicable to the sku. Possible
 * values include: 'Automatic', 'None'
 * 
 */
function VirtualMachineScaleSetSkuCapacity() {
}

/**
 * Defines the metadata of VirtualMachineScaleSetSkuCapacity
 *
 * @returns {object} metadata of VirtualMachineScaleSetSkuCapacity
 *
 */
VirtualMachineScaleSetSkuCapacity.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineScaleSetSkuCapacity',
    type: {
      name: 'Composite',
      className: 'VirtualMachineScaleSetSkuCapacity',
      modelProperties: {
        minimum: {
          required: false,
          readOnly: true,
          serializedName: 'minimum',
          type: {
            name: 'Number'
          }
        },
        maximum: {
          required: false,
          readOnly: true,
          serializedName: 'maximum',
          type: {
            name: 'Number'
          }
        },
        defaultCapacity: {
          required: false,
          readOnly: true,
          serializedName: 'defaultCapacity',
          type: {
            name: 'Number'
          }
        },
        scaleType: {
          required: false,
          readOnly: true,
          serializedName: 'scaleType',
          type: {
            name: 'Enum',
            allowedValues: [ 'Automatic', 'None' ]
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineScaleSetSkuCapacity;
