/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualMachineScaleSetVMExtensionsSummary class.
 * @constructor
 * Extensions summary for virtual machines of a virtual machine scale set.
 * @member {string} [name] the extension name.
 * 
 * @member {array} [statusesSummary] the extensions information.
 * 
 */
function VirtualMachineScaleSetVMExtensionsSummary() {
}

/**
 * Defines the metadata of VirtualMachineScaleSetVMExtensionsSummary
 *
 * @returns {object} metadata of VirtualMachineScaleSetVMExtensionsSummary
 *
 */
VirtualMachineScaleSetVMExtensionsSummary.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineScaleSetVMExtensionsSummary',
    type: {
      name: 'Composite',
      className: 'VirtualMachineScaleSetVMExtensionsSummary',
      modelProperties: {
        name: {
          required: false,
          readOnly: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        statusesSummary: {
          required: false,
          readOnly: true,
          serializedName: 'statusesSummary',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'VirtualMachineStatusCodeCountElementType',
                type: {
                  name: 'Composite',
                  className: 'VirtualMachineStatusCodeCount'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineScaleSetVMExtensionsSummary;
