/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualMachineScaleSetVMInstanceView class.
 * @constructor
 * The instance view of a virtual machine scale set VM.
 * @member {number} [platformUpdateDomain] the Update Domain count.
 * 
 * @member {number} [platformFaultDomain] the Fault Domain count.
 * 
 * @member {string} [rdpThumbPrint] the Remote desktop certificate thumbprint.
 * 
 * @member {object} [vmAgent] the VM Agent running on the virtual machine.
 * 
 * @member {string} [vmAgent.vmAgentVersion] the VM Agent full version.
 * 
 * @member {array} [vmAgent.extensionHandlers] the virtual machine extension
 * handler instance view.
 * 
 * @member {array} [vmAgent.statuses] the resource status information.
 * 
 * @member {array} [disks] the disks information.
 * 
 * @member {array} [extensions] the extensions information.
 * 
 * @member {object} [bootDiagnostics] the boot diagnostics.
 * 
 * @member {string} [bootDiagnostics.consoleScreenshotBlobUri] the console
 * screenshot blob Uri.
 * 
 * @member {string} [bootDiagnostics.serialConsoleLogBlobUri] the Linux serial
 * console log blob Uri.
 * 
 * @member {array} [statuses] the resource status information.
 * 
 */
function VirtualMachineScaleSetVMInstanceView() {
}

/**
 * Defines the metadata of VirtualMachineScaleSetVMInstanceView
 *
 * @returns {object} metadata of VirtualMachineScaleSetVMInstanceView
 *
 */
VirtualMachineScaleSetVMInstanceView.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineScaleSetVMInstanceView',
    type: {
      name: 'Composite',
      className: 'VirtualMachineScaleSetVMInstanceView',
      modelProperties: {
        platformUpdateDomain: {
          required: false,
          serializedName: 'platformUpdateDomain',
          type: {
            name: 'Number'
          }
        },
        platformFaultDomain: {
          required: false,
          serializedName: 'platformFaultDomain',
          type: {
            name: 'Number'
          }
        },
        rdpThumbPrint: {
          required: false,
          serializedName: 'rdpThumbPrint',
          type: {
            name: 'String'
          }
        },
        vmAgent: {
          required: false,
          serializedName: 'vmAgent',
          type: {
            name: 'Composite',
            className: 'VirtualMachineAgentInstanceView'
          }
        },
        disks: {
          required: false,
          serializedName: 'disks',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'DiskInstanceViewElementType',
                type: {
                  name: 'Composite',
                  className: 'DiskInstanceView'
                }
            }
          }
        },
        extensions: {
          required: false,
          serializedName: 'extensions',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'VirtualMachineExtensionInstanceViewElementType',
                type: {
                  name: 'Composite',
                  className: 'VirtualMachineExtensionInstanceView'
                }
            }
          }
        },
        bootDiagnostics: {
          required: false,
          serializedName: 'bootDiagnostics',
          type: {
            name: 'Composite',
            className: 'BootDiagnosticsInstanceView'
          }
        },
        statuses: {
          required: false,
          serializedName: 'statuses',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'InstanceViewStatusElementType',
                type: {
                  name: 'Composite',
                  className: 'InstanceViewStatus'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineScaleSetVMInstanceView;
