/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualMachineScaleSetVMListResult class.
 * @constructor
 * The List Virtual Machine Scale Set VMs operation response.
 * @member {array} [value] the list of virtual machine scale sets VMs.
 * 
 * @member {string} [nextLink] the uri to fetch the next page of Virtual
 * Machine Scale Set VMs. Call ListNext() with this to fetch the next page of
 * VMSS VMs
 * 
 */
function VirtualMachineScaleSetVMListResult() {
}

util.inherits(VirtualMachineScaleSetVMListResult, Array);

/**
 * Defines the metadata of VirtualMachineScaleSetVMListResult
 *
 * @returns {object} metadata of VirtualMachineScaleSetVMListResult
 *
 */
VirtualMachineScaleSetVMListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualMachineScaleSetVMListResult',
    type: {
      name: 'Composite',
      className: 'VirtualMachineScaleSetVMListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'VirtualMachineScaleSetVMElementType',
                type: {
                  name: 'Composite',
                  className: 'VirtualMachineScaleSetVM'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = VirtualMachineScaleSetVMListResult;
