/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the WinRMConfiguration class.
 * @constructor
 * Describes Windows Remote Management configuration of the VM
 * @member {array} [listeners] the list of Windows Remote Management listeners
 * 
 */
function WinRMConfiguration() {
}

/**
 * Defines the metadata of WinRMConfiguration
 *
 * @returns {object} metadata of WinRMConfiguration
 *
 */
WinRMConfiguration.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'WinRMConfiguration',
    type: {
      name: 'Composite',
      className: 'WinRMConfiguration',
      modelProperties: {
        listeners: {
          required: false,
          serializedName: 'listeners',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'WinRMListenerElementType',
                type: {
                  name: 'Composite',
                  className: 'WinRMListener'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = WinRMConfiguration;
