/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the WindowsConfiguration class.
 * @constructor
 * Describes Windows Configuration of the OS Profile.
 * @member {boolean} [provisionVMAgent] whether VM Agent should be provisioned
 * on the Virtual Machine.
 * 
 * @member {boolean} [enableAutomaticUpdates] whether Windows updates are
 * automatically installed on the VM
 * 
 * @member {string} [timeZone] the Time Zone of the VM
 * 
 * @member {array} [additionalUnattendContent] the additional base-64 encoded
 * XML formatted information that can be included in the Unattend.xml file.
 * 
 * @member {object} [winRM] the Windows Remote Management configuration of the
 * VM
 * 
 * @member {array} [winRM.listeners] the list of Windows Remote Management
 * listeners
 * 
 */
function WindowsConfiguration() {
}

/**
 * Defines the metadata of WindowsConfiguration
 *
 * @returns {object} metadata of WindowsConfiguration
 *
 */
WindowsConfiguration.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'WindowsConfiguration',
    type: {
      name: 'Composite',
      className: 'WindowsConfiguration',
      modelProperties: {
        provisionVMAgent: {
          required: false,
          serializedName: 'provisionVMAgent',
          type: {
            name: 'Boolean'
          }
        },
        enableAutomaticUpdates: {
          required: false,
          serializedName: 'enableAutomaticUpdates',
          type: {
            name: 'Boolean'
          }
        },
        timeZone: {
          required: false,
          serializedName: 'timeZone',
          type: {
            name: 'String'
          }
        },
        additionalUnattendContent: {
          required: false,
          serializedName: 'additionalUnattendContent',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'AdditionalUnattendContentElementType',
                type: {
                  name: 'Composite',
                  className: 'AdditionalUnattendContent'
                }
            }
          }
        },
        winRM: {
          required: false,
          serializedName: 'winRM',
          type: {
            name: 'Composite',
            className: 'WinRMConfiguration'
          }
        }
      }
    }
  };
};

module.exports = WindowsConfiguration;
