/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the AddStorageAccountParameters class.
 * @constructor
 * Additional Azure Storage account parameters.
 *
 * @member {object} properties the properties for the Azure Storage account
 * being added.
 * 
 * @member {string} [properties.accessKey] the access key associated with this
 * Azure Storage account that will be used to connect to it.
 * 
 * @member {string} [properties.suffix] the optional suffix for the Data Lake
 * account.
 * 
 */
function AddStorageAccountParameters() {
}

/**
 * Defines the metadata of AddStorageAccountParameters
 *
 * @returns {object} metadata of AddStorageAccountParameters
 *
 */
AddStorageAccountParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AddStorageAccountParameters',
    type: {
      name: 'Composite',
      className: 'AddStorageAccountParameters',
      modelProperties: {
        properties: {
          required: true,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'StorageAccountProperties'
          }
        }
      }
    }
  };
};

module.exports = AddStorageAccountParameters;
