/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the BlobContainer class.
 * @constructor
 * Azure Storage blob container information.
 *
 * @member {string} [name] the name of the blob container.
 * 
 * @member {string} [id] the unique identifier of the blob container.
 * 
 * @member {string} [type] the type of the blob container.
 * 
 * @member {object} [properties] the properties of the blob container.
 * 
 * @member {date} [properties.lastModifiedTime] the last modified time of the
 * blob container.
 * 
 */
function BlobContainer() {
}

/**
 * Defines the metadata of BlobContainer
 *
 * @returns {object} metadata of BlobContainer
 *
 */
BlobContainer.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'BlobContainer',
    type: {
      name: 'Composite',
      className: 'BlobContainer',
      modelProperties: {
        name: {
          required: false,
          readOnly: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        id: {
          required: false,
          readOnly: true,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          readOnly: true,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        properties: {
          required: false,
          readOnly: true,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'BlobContainerProperties'
          }
        }
      }
    }
  };
};

module.exports = BlobContainer;
