/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the DataLakeStoreAccountInfo class.
 * @constructor
 * Data Lake Store account information.
 *
 * @member {string} name the account name of the Data Lake Store account.
 * 
 * @member {object} [properties] the properties associated with this Data Lake
 * Store account.
 * 
 * @member {string} [properties.suffix] the optional suffix for the Data Lake
 * Store account.
 * 
 */
function DataLakeStoreAccountInfo() {
}

/**
 * Defines the metadata of DataLakeStoreAccountInfo
 *
 * @returns {object} metadata of DataLakeStoreAccountInfo
 *
 */
DataLakeStoreAccountInfo.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DataLakeStoreAccountInfo',
    type: {
      name: 'Composite',
      className: 'DataLakeStoreAccountInfo',
      modelProperties: {
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'DataLakeStoreAccountInfoProperties'
          }
        }
      }
    }
  };
};

module.exports = DataLakeStoreAccountInfo;
