/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the StorageAccountInfo class.
 * @constructor
 * Azure Storage account information.
 *
 * @member {string} name the account name associated with the Azure storage
 * account.
 * 
 * @member {object} properties the properties associated with this storage
 * account.
 * 
 * @member {string} [properties.accessKey] the access key associated with this
 * Azure Storage account that will be used to connect to it.
 * 
 * @member {string} [properties.suffix] the optional suffix for the Data Lake
 * account.
 * 
 */
function StorageAccountInfo() {
}

/**
 * Defines the metadata of StorageAccountInfo
 *
 * @returns {object} metadata of StorageAccountInfo
 *
 */
StorageAccountInfo.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'StorageAccountInfo',
    type: {
      name: 'Composite',
      className: 'StorageAccountInfo',
      modelProperties: {
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        properties: {
          required: true,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'StorageAccountProperties'
          }
        }
      }
    }
  };
};

module.exports = StorageAccountInfo;
