/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the CatalogItem class.
 * @constructor
 * A Data Lake Analytics catalog item.
 *
 * @member {string} [computeAccountName] the name of the Data Lake Analytics
 * account.
 * 
 * @member {uuid} [version] the version of the catalog item.
 * 
 */
function CatalogItem() {
}

/**
 * Defines the metadata of CatalogItem
 *
 * @returns {object} metadata of CatalogItem
 *
 */
CatalogItem.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CatalogItem',
    type: {
      name: 'Composite',
      className: 'CatalogItem',
      modelProperties: {
        computeAccountName: {
          required: false,
          serializedName: 'computeAccountName',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CatalogItem;
