/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the DdlName class.
 * @constructor
 * A Data Lake Analytics DDL name item.
 *
 * @member {string} [firstPart] the name of the table associated with this
 * database and schema.
 * 
 * @member {string} [secondPart] the name of the table associated with this
 * database and schema.
 * 
 * @member {string} [thirdPart] the name of the table associated with this
 * database and schema.
 * 
 * @member {string} [server] the name of the table associated with this
 * database and schema.
 * 
 */
function DdlName() {
}

/**
 * Defines the metadata of DdlName
 *
 * @returns {object} metadata of DdlName
 *
 */
DdlName.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DdlName',
    type: {
      name: 'Composite',
      className: 'DdlName',
      modelProperties: {
        firstPart: {
          required: false,
          serializedName: 'firstPart',
          type: {
            name: 'String'
          }
        },
        secondPart: {
          required: false,
          serializedName: 'secondPart',
          type: {
            name: 'String'
          }
        },
        thirdPart: {
          required: false,
          serializedName: 'thirdPart',
          type: {
            name: 'String'
          }
        },
        server: {
          required: false,
          serializedName: 'server',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = DdlName;
