/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the EntityId class.
 * @constructor
 * A Data Lake Analytics catalog entity identifier object.
 *
 * @member {object} [name] the name of the external table associated with this
 * database, schema and table.
 * 
 * @member {string} [name.firstPart] the name of the table associated with
 * this database and schema.
 * 
 * @member {string} [name.secondPart] the name of the table associated with
 * this database and schema.
 * 
 * @member {string} [name.thirdPart] the name of the table associated with
 * this database and schema.
 * 
 * @member {string} [name.server] the name of the table associated with this
 * database and schema.
 * 
 * @member {uuid} [version] the version of the external data source.
 * 
 */
function EntityId() {
}

/**
 * Defines the metadata of EntityId
 *
 * @returns {object} metadata of EntityId
 *
 */
EntityId.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'EntityId',
    type: {
      name: 'Composite',
      className: 'EntityId',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'Composite',
            className: 'DdlName'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = EntityId;
