/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the USqlAssembly class.
 * @constructor
 * A Data Lake Analytics catalog U-SQL Assembly.
 *
 * @member {string} [databaseName] the name of the database.
 * 
 * @member {string} [name] the name of the assembly.
 * 
 * @member {string} [clrName] the name of the CLR.
 * 
 * @member {boolean} [isVisible] the switch indicating if this assembly is
 * visible or not.
 * 
 * @member {boolean} [isUserDefined] the switch indicating if this assembly is
 * user defined or not.
 * 
 * @member {array} [files] the list of files associated with the assembly
 * 
 * @member {array} [dependencies] the list of dependencies associated with the
 * assembly
 * 
 */
function USqlAssembly() {
  USqlAssembly['super_'].call(this);
}

util.inherits(USqlAssembly, models['CatalogItem']);

/**
 * Defines the metadata of USqlAssembly
 *
 * @returns {object} metadata of USqlAssembly
 *
 */
USqlAssembly.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'USqlAssembly',
    type: {
      name: 'Composite',
      className: 'USqlAssembly',
      modelProperties: {
        computeAccountName: {
          required: false,
          serializedName: 'computeAccountName',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        },
        databaseName: {
          required: false,
          serializedName: 'databaseName',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'assemblyName',
          type: {
            name: 'String'
          }
        },
        clrName: {
          required: false,
          serializedName: 'clrName',
          type: {
            name: 'String'
          }
        },
        isVisible: {
          required: false,
          serializedName: 'isVisible',
          type: {
            name: 'Boolean'
          }
        },
        isUserDefined: {
          required: false,
          serializedName: 'isUserDefined',
          type: {
            name: 'Boolean'
          }
        },
        files: {
          required: false,
          serializedName: 'files',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'USqlAssemblyFileInfoElementType',
                type: {
                  name: 'Composite',
                  className: 'USqlAssemblyFileInfo'
                }
            }
          }
        },
        dependencies: {
          required: false,
          serializedName: 'dependencies',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'USqlAssemblyDependencyInfoElementType',
                type: {
                  name: 'Composite',
                  className: 'USqlAssemblyDependencyInfo'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = USqlAssembly;
