/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the USqlAssemblyFileInfo class.
 * @constructor
 * A Data Lake Analytics catalog U-SQL assembly file information item.
 *
 * @member {string} [type] the assembly file type. Possible values include:
 * 'Assembly', 'Resource'
 * 
 * @member {string} [originalPath] the the original path to the assembly file.
 * 
 * @member {string} [contentPath] the the content path to the assembly file.
 * 
 */
function USqlAssemblyFileInfo() {
}

/**
 * Defines the metadata of USqlAssemblyFileInfo
 *
 * @returns {object} metadata of USqlAssemblyFileInfo
 *
 */
USqlAssemblyFileInfo.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'USqlAssemblyFileInfo',
    type: {
      name: 'Composite',
      className: 'USqlAssemblyFileInfo',
      modelProperties: {
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'Enum',
            allowedValues: [ 'Assembly', 'Resource' ]
          }
        },
        originalPath: {
          required: false,
          serializedName: 'originalPath',
          type: {
            name: 'String'
          }
        },
        contentPath: {
          required: false,
          serializedName: 'contentPath',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = USqlAssemblyFileInfo;
