/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the USqlCredential class.
 * @constructor
 * A Data Lake Analytics catalog U-SQL credential item.
 *
 * @member {string} [databaseName] the name of the database the credential is
 * in.
 * 
 * @member {string} [identity] the name of the secret associated with the
 * credential.
 * 
 * @member {string} [name] the name of the credential.
 * 
 * @member {string} [userName] the user name associated with the credential.
 * 
 */
function USqlCredential() {
  USqlCredential['super_'].call(this);
}

util.inherits(USqlCredential, models['CatalogItem']);

/**
 * Defines the metadata of USqlCredential
 *
 * @returns {object} metadata of USqlCredential
 *
 */
USqlCredential.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'USqlCredential',
    type: {
      name: 'Composite',
      className: 'USqlCredential',
      modelProperties: {
        computeAccountName: {
          required: false,
          serializedName: 'computeAccountName',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        },
        databaseName: {
          required: false,
          serializedName: 'databaseName',
          type: {
            name: 'String'
          }
        },
        identity: {
          required: false,
          serializedName: 'identity',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'credentialName',
          type: {
            name: 'String'
          }
        },
        userName: {
          required: false,
          serializedName: 'userName',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = USqlCredential;
