/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the USqlExternalDataSource class.
 * @constructor
 * A Data Lake Analytics catalog U-SQL external datasource item.
 *
 * @member {string} [databaseName] the name of the database.
 * 
 * @member {string} [name] the name of the external data source.
 * 
 * @member {string} [provider] the name of the provider for the external data
 * source.
 * 
 * @member {string} [providerString] the name of the provider string for the
 * external data source.
 * 
 * @member {array} [pushdownTypes] the list of types to push down from the
 * external data source.
 * 
 */
function USqlExternalDataSource() {
  USqlExternalDataSource['super_'].call(this);
}

util.inherits(USqlExternalDataSource, models['CatalogItem']);

/**
 * Defines the metadata of USqlExternalDataSource
 *
 * @returns {object} metadata of USqlExternalDataSource
 *
 */
USqlExternalDataSource.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'USqlExternalDataSource',
    type: {
      name: 'Composite',
      className: 'USqlExternalDataSource',
      modelProperties: {
        computeAccountName: {
          required: false,
          serializedName: 'computeAccountName',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        },
        databaseName: {
          required: false,
          serializedName: 'databaseName',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'externalDataSourceName',
          type: {
            name: 'String'
          }
        },
        provider: {
          required: false,
          serializedName: 'provider',
          type: {
            name: 'String'
          }
        },
        providerString: {
          required: false,
          serializedName: 'providerString',
          type: {
            name: 'String'
          }
        },
        pushdownTypes: {
          required: false,
          serializedName: 'pushdownTypes',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = USqlExternalDataSource;
