/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the USqlSchema class.
 * @constructor
 * A Data Lake Analytics catalog U-SQL schema item.
 *
 * @member {string} [databaseName] the name of the database.
 * 
 * @member {string} [name] the name of the schema.
 * 
 */
function USqlSchema() {
  USqlSchema['super_'].call(this);
}

util.inherits(USqlSchema, models['CatalogItem']);

/**
 * Defines the metadata of USqlSchema
 *
 * @returns {object} metadata of USqlSchema
 *
 */
USqlSchema.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'USqlSchema',
    type: {
      name: 'Composite',
      className: 'USqlSchema',
      modelProperties: {
        computeAccountName: {
          required: false,
          serializedName: 'computeAccountName',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        },
        databaseName: {
          required: false,
          serializedName: 'databaseName',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'schemaName',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = USqlSchema;
