/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the USqlTableColumn class.
 * @constructor
 * A Data Lake Analytics catalog U-SQL table column item.
 *
 * @member {string} [name] the name of the column in the table.
 * 
 * @member {string} [type] the object type of the specified column (such as
 * System.String).
 * 
 */
function USqlTableColumn() {
}

/**
 * Defines the metadata of USqlTableColumn
 *
 * @returns {object} metadata of USqlTableColumn
 *
 */
USqlTableColumn.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'USqlTableColumn',
    type: {
      name: 'Composite',
      className: 'USqlTableColumn',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = USqlTableColumn;
