/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the USqlTableStatisticsList class.
 * @constructor
 * A Data Lake Analytics catalog U-SQL table statistics item list.
 * @member {array} [value] the list of table statistics in the database,
 * schema and table combination
 * 
 */
function USqlTableStatisticsList() {
}

util.inherits(USqlTableStatisticsList, Array);

/**
 * Defines the metadata of USqlTableStatisticsList
 *
 * @returns {object} metadata of USqlTableStatisticsList
 *
 */
USqlTableStatisticsList.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'USqlTableStatisticsList',
    type: {
      name: 'Composite',
      className: 'USqlTableStatisticsList',
      modelProperties: {
        count: {
          required: false,
          serializedName: 'count',
          type: {
            name: 'Number'
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        },
        value: {
          required: false,
          readOnly: true,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'USqlTableStatisticsElementType',
                type: {
                  name: 'Composite',
                  className: 'USqlTableStatistics'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = USqlTableStatisticsList;
