/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the USqlTableValuedFunctionList class.
 * @constructor
 * A Data Lake Analytics catalog U-SQL table valued function item list.
 * @member {array} [value] the list of table valued functions in the database
 * and schema combination
 * 
 */
function USqlTableValuedFunctionList() {
}

util.inherits(USqlTableValuedFunctionList, Array);

/**
 * Defines the metadata of USqlTableValuedFunctionList
 *
 * @returns {object} metadata of USqlTableValuedFunctionList
 *
 */
USqlTableValuedFunctionList.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'USqlTableValuedFunctionList',
    type: {
      name: 'Composite',
      className: 'USqlTableValuedFunctionList',
      modelProperties: {
        count: {
          required: false,
          serializedName: 'count',
          type: {
            name: 'Number'
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        },
        value: {
          required: false,
          readOnly: true,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'USqlTableValuedFunctionElementType',
                type: {
                  name: 'Composite',
                  className: 'USqlTableValuedFunction'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = USqlTableValuedFunctionList;
