/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the HiveJobProperties class.
 * @constructor
 * @member {array} [statementInfo] the statement information for each
 * statement in the script
 * 
 * @member {string} [logsLocation] the Hive logs location
 * 
 * @member {string} [warehouseLocation] the location of the Hive warehouse
 * 
 * @member {number} [statementCount] the number of statements that will be run
 * based on the script
 * 
 * @member {number} [executedStatementCount] the number of statements that
 * have been run based on the script
 * 
 */
function HiveJobProperties() {
  HiveJobProperties['super_'].call(this);
}

util.inherits(HiveJobProperties, models['JobProperties']);

/**
 * Defines the metadata of HiveJobProperties
 *
 * @returns {object} metadata of HiveJobProperties
 *
 */
HiveJobProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Hive',
    type: {
      name: 'Composite',
      className: 'HiveJobProperties',
      modelProperties: {
        runtimeVersion: {
          required: false,
          serializedName: 'runtimeVersion',
          type: {
            name: 'String'
          }
        },
        script: {
          required: true,
          serializedName: 'script',
          type: {
            name: 'String'
          }
        },
        type: {
          required: true,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        statementInfo: {
          required: false,
          serializedName: 'statementInfo',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'HiveJobStatementInfoElementType',
                type: {
                  name: 'Composite',
                  className: 'HiveJobStatementInfo'
                }
            }
          }
        },
        logsLocation: {
          required: false,
          serializedName: 'logsLocation',
          type: {
            name: 'String'
          }
        },
        warehouseLocation: {
          required: false,
          serializedName: 'warehouseLocation',
          type: {
            name: 'String'
          }
        },
        statementCount: {
          required: false,
          serializedName: 'statementCount',
          type: {
            name: 'Number'
          }
        },
        executedStatementCount: {
          required: false,
          serializedName: 'executedStatementCount',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = HiveJobProperties;
