/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the JobDataPath class.
 * @constructor
 * A Data Lake Analytics job data path item.
 *
 * @member {uuid} [jobId] the id of the job this data is for.
 * 
 * @member {string} [command] the command that this job data relates to.
 * 
 * @member {array} [paths] the list of paths to all of the job data.
 * 
 */
function JobDataPath() {
}

/**
 * Defines the metadata of JobDataPath
 *
 * @returns {object} metadata of JobDataPath
 *
 */
JobDataPath.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'JobDataPath',
    type: {
      name: 'Composite',
      className: 'JobDataPath',
      modelProperties: {
        jobId: {
          required: false,
          readOnly: true,
          serializedName: 'jobId',
          type: {
            name: 'String'
          }
        },
        command: {
          required: false,
          readOnly: true,
          serializedName: 'command',
          type: {
            name: 'String'
          }
        },
        paths: {
          required: false,
          readOnly: true,
          serializedName: 'paths',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = JobDataPath;
