/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the JobInfoListResult class.
 * @constructor
 * List of jobInfo items.
 * @member {array} [value] the list of jobInfo items.
 * 
 * @member {string} [nextLink] the link (url) to the next page of results.
 * 
 * @member {number} [count] the total count of results that are available, but
 * might not be returned in the current page.
 * 
 */
function JobInfoListResult() {
}

util.inherits(JobInfoListResult, Array);

/**
 * Defines the metadata of JobInfoListResult
 *
 * @returns {object} metadata of JobInfoListResult
 *
 */
JobInfoListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'JobInfoListResult',
    type: {
      name: 'Composite',
      className: 'JobInfoListResult',
      modelProperties: {
        value: {
          required: false,
          readOnly: true,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'JobInformationElementType',
                type: {
                  name: 'Composite',
                  className: 'JobInformation'
                }
            }
          }
        },
        nextLink: {
          required: false,
          readOnly: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        },
        count: {
          required: false,
          readOnly: true,
          serializedName: 'count',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = JobInfoListResult;
