/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the JobResource class.
 * @constructor
 * The Data Lake Analytics job resources.
 *
 * @member {string} [name] the name of the resource.
 * 
 * @member {string} [resourcePath] the path to the resource.
 * 
 * @member {string} [type] the job resource type. Possible values include:
 * 'VertexResource', 'JobManagerResource', 'StatisticsResource',
 * 'VertexResourceInUserFolder', 'JobManagerResourceInUserFolder',
 * 'StatisticsResourceInUserFolder'
 * 
 */
function JobResource() {
}

/**
 * Defines the metadata of JobResource
 *
 * @returns {object} metadata of JobResource
 *
 */
JobResource.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'JobResource',
    type: {
      name: 'Composite',
      className: 'JobResource',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        resourcePath: {
          required: false,
          serializedName: 'resourcePath',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'Enum',
            allowedValues: [ 'VertexResource', 'JobManagerResource', 'StatisticsResource', 'VertexResourceInUserFolder', 'JobManagerResourceInUserFolder', 'StatisticsResourceInUserFolder' ]
          }
        }
      }
    }
  };
};

module.exports = JobResource;
