/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the JobStatistics class.
 * @constructor
 * The Data Lake Analytics job execution statistics.
 *
 * @member {date} [lastUpdateTimeUtc] the last update time for the statistics.
 * 
 * @member {array} [stages] the list of stages for the job.
 * 
 */
function JobStatistics() {
}

/**
 * Defines the metadata of JobStatistics
 *
 * @returns {object} metadata of JobStatistics
 *
 */
JobStatistics.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'JobStatistics',
    type: {
      name: 'Composite',
      className: 'JobStatistics',
      modelProperties: {
        lastUpdateTimeUtc: {
          required: false,
          readOnly: true,
          serializedName: 'lastUpdateTimeUtc',
          type: {
            name: 'DateTime'
          }
        },
        stages: {
          required: false,
          readOnly: true,
          serializedName: 'stages',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'JobStatisticsVertexStageElementType',
                type: {
                  name: 'Composite',
                  className: 'JobStatisticsVertexStage'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = JobStatistics;
