/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the DataLakeStoreAccountListResult class.
 * @constructor
 * Data Lake Store account list information response.
 * @member {array} [value] the results of the list operation
 * 
 * @member {string} [nextLink] the link (url) to the next page of results.
 * 
 * @member {number} [count] the total count of results that are available, but
 * might not be returned in the current page.
 * 
 */
function DataLakeStoreAccountListResult() {
}

util.inherits(DataLakeStoreAccountListResult, Array);

/**
 * Defines the metadata of DataLakeStoreAccountListResult
 *
 * @returns {object} metadata of DataLakeStoreAccountListResult
 *
 */
DataLakeStoreAccountListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DataLakeStoreAccountListResult',
    type: {
      name: 'Composite',
      className: 'DataLakeStoreAccountListResult',
      modelProperties: {
        value: {
          required: false,
          readOnly: true,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'DataLakeStoreAccountElementType',
                type: {
                  name: 'Composite',
                  className: 'DataLakeStoreAccount'
                }
            }
          }
        },
        nextLink: {
          required: false,
          readOnly: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        },
        count: {
          required: false,
          readOnly: true,
          serializedName: 'count',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = DataLakeStoreAccountListResult;
