/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the DataLakeStoreAccountProperties class.
 * @constructor
 * Data Lake Store account properties information
 *
 * @member {string} [provisioningState] the status of the Data Lake Store
 * account while being provisioned. Possible values include: 'Failed',
 * 'Creating', 'Running', 'Succeeded', 'Patching', 'Suspending', 'Resuming',
 * 'Deleting', 'Deleted'
 * 
 * @member {string} [state] the status of the Data Lake Store account after
 * provisioning has completed. Possible values include: 'active', 'suspended'
 * 
 * @member {date} [creationTime] the account creation time.
 * 
 * @member {date} [lastModifiedTime] the account last modified time.
 * 
 * @member {string} [endpoint] the gateway host.
 * 
 * @member {string} [defaultGroup] the default owner group for all new folders
 * and files created in the Data Lake Store account.
 * 
 */
function DataLakeStoreAccountProperties() {
}

/**
 * Defines the metadata of DataLakeStoreAccountProperties
 *
 * @returns {object} metadata of DataLakeStoreAccountProperties
 *
 */
DataLakeStoreAccountProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DataLakeStoreAccountProperties',
    type: {
      name: 'Composite',
      className: 'DataLakeStoreAccountProperties',
      modelProperties: {
        provisioningState: {
          required: false,
          readOnly: true,
          serializedName: 'provisioningState',
          type: {
            name: 'Enum',
            allowedValues: [ 'Failed', 'Creating', 'Running', 'Succeeded', 'Patching', 'Suspending', 'Resuming', 'Deleting', 'Deleted' ]
          }
        },
        state: {
          required: false,
          readOnly: true,
          serializedName: 'state',
          type: {
            name: 'Enum',
            allowedValues: [ 'active', 'suspended' ]
          }
        },
        creationTime: {
          required: false,
          readOnly: true,
          serializedName: 'creationTime',
          type: {
            name: 'DateTime'
          }
        },
        lastModifiedTime: {
          required: false,
          readOnly: true,
          serializedName: 'lastModifiedTime',
          type: {
            name: 'DateTime'
          }
        },
        endpoint: {
          required: false,
          serializedName: 'endpoint',
          type: {
            name: 'String'
          }
        },
        defaultGroup: {
          required: false,
          serializedName: 'defaultGroup',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = DataLakeStoreAccountProperties;
