/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the FirewallRule class.
 * @constructor
 * Data Lake Store firewall rule information
 *
 * @member {string} [name] the firewall rule's name.
 * 
 * @member {string} [type] the namespace and type of the firewall Rule.
 * 
 * @member {string} [id] the firewall rule's subscription ID.
 * 
 * @member {string} [location] the firewall rule's regional location.
 * 
 * @member {object} [properties] the properties of the firewall rule.
 * 
 * @member {string} [properties.startIpAddress] the start IP address for the
 * firewall rule.
 * 
 * @member {string} [properties.endIpAddress] the end IP address for the
 * firewall rule.
 * 
 */
function FirewallRule() {
}

/**
 * Defines the metadata of FirewallRule
 *
 * @returns {object} metadata of FirewallRule
 *
 */
FirewallRule.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'FirewallRule',
    type: {
      name: 'Composite',
      className: 'FirewallRule',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          readOnly: true,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'FirewallRuleProperties'
          }
        }
      }
    }
  };
};

module.exports = FirewallRule;
