/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the AclStatusResult class.
 * @constructor
 * Data Lake Store file or directory Access Control List information.
 *
 * @member {object} [aclStatus] the AclStatus object for a given file or
 * directory.
 * 
 * @member {array} [aclStatus.entries] the list of ACLSpec entries on a file
 * or directory.
 * 
 * @member {string} [aclStatus.group] the group owner, an AAD Object ID.
 * 
 * @member {string} [aclStatus.owner] the user owner, an AAD Object ID.
 * 
 * @member {boolean} [aclStatus.stickyBit] the indicator of whether the sticky
 * bit is on or off.
 * 
 */
function AclStatusResult() {
}

/**
 * Defines the metadata of AclStatusResult
 *
 * @returns {object} metadata of AclStatusResult
 *
 */
AclStatusResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AclStatusResult',
    type: {
      name: 'Composite',
      className: 'AclStatusResult',
      modelProperties: {
        aclStatus: {
          required: false,
          serializedName: 'AclStatus',
          type: {
            name: 'Composite',
            className: 'AclStatus'
          }
        }
      }
    }
  };
};

module.exports = AclStatusResult;
