/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the AdlsAccessControlException class.
 * @constructor
 * A WebHDFS exception thrown indicating that access is denied due to
 * insufficient permissions. Thrown when a 403 error response code is
 * returned (forbidden).
 *
 */
function AdlsAccessControlException() {
  AdlsAccessControlException['super_'].call(this);
}

util.inherits(AdlsAccessControlException, models['AdlsRemoteException']);

/**
 * Defines the metadata of AdlsAccessControlException
 *
 * @returns {object} metadata of AdlsAccessControlException
 *
 */
AdlsAccessControlException.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AccessControlException',
    type: {
      name: 'Composite',
      className: 'AdlsAccessControlException',
      modelProperties: {
        javaClassName: {
          required: false,
          readOnly: true,
          serializedName: 'javaClassName',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          readOnly: true,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        },
        exception: {
          required: true,
          serializedName: 'exception',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AdlsAccessControlException;
