/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the AdlsError class.
 * @constructor
 * Data Lake Store filesystem error containing a specific WebHDFS exception.
 *
 * @member {object} [remoteException] the object representing the actual
 * WebHDFS exception being returned.
 * 
 * @member {string} [remoteException.javaClassName] the full class package
 * name for the exception thrown, such as
 * 'java.lang.IllegalArgumentException'.
 * 
 * @member {string} [remoteException.message] the message associated with the
 * exception that was thrown, such as 'Invalid value for webhdfs parameter
 * "permission":...'.
 * 
 * @member {string} [remoteException.exception] Polymorhpic Discriminator
 * 
 */
function AdlsError() {
}

/**
 * Defines the metadata of AdlsError
 *
 * @returns {object} metadata of AdlsError
 *
 */
AdlsError.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AdlsError',
    type: {
      name: 'Composite',
      className: 'AdlsError',
      modelProperties: {
        remoteException: {
          required: false,
          readOnly: true,
          serializedName: 'RemoteException',
          type: {
            name: 'Composite',
            polymorphicDiscriminator: 'exception',
            uberParent: 'AdlsRemoteException',
            className: 'AdlsRemoteException'
          }
        }
      }
    }
  };
};

module.exports = AdlsError;
