/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the AdlsFileNotFoundException class.
 * @constructor
 * A WebHDFS exception thrown indicating the file or folder could not be
 * found. Thrown when a 404 error response code is returned (not found).
 *
 */
function AdlsFileNotFoundException() {
  AdlsFileNotFoundException['super_'].call(this);
}

util.inherits(AdlsFileNotFoundException, models['AdlsRemoteException']);

/**
 * Defines the metadata of AdlsFileNotFoundException
 *
 * @returns {object} metadata of AdlsFileNotFoundException
 *
 */
AdlsFileNotFoundException.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'FileNotFoundException',
    type: {
      name: 'Composite',
      className: 'AdlsFileNotFoundException',
      modelProperties: {
        javaClassName: {
          required: false,
          readOnly: true,
          serializedName: 'javaClassName',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          readOnly: true,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        },
        exception: {
          required: true,
          serializedName: 'exception',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AdlsFileNotFoundException;
