/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the AdlsIllegalArgumentException class.
 * @constructor
 * A WebHDFS exception thrown indicating that one more arguments is incorrect.
 * Thrown when a 400 error response code is returned (bad request).
 *
 */
function AdlsIllegalArgumentException() {
  AdlsIllegalArgumentException['super_'].call(this);
}

util.inherits(AdlsIllegalArgumentException, models['AdlsRemoteException']);

/**
 * Defines the metadata of AdlsIllegalArgumentException
 *
 * @returns {object} metadata of AdlsIllegalArgumentException
 *
 */
AdlsIllegalArgumentException.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'IllegalArgumentException',
    type: {
      name: 'Composite',
      className: 'AdlsIllegalArgumentException',
      modelProperties: {
        javaClassName: {
          required: false,
          readOnly: true,
          serializedName: 'javaClassName',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          readOnly: true,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        },
        exception: {
          required: true,
          serializedName: 'exception',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AdlsIllegalArgumentException;
