/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the AdlsSecurityException class.
 * @constructor
 * A WebHDFS exception thrown indicating that access is denied. Thrown when a
 * 401 error response code is returned (Unauthorized).
 *
 */
function AdlsSecurityException() {
  AdlsSecurityException['super_'].call(this);
}

util.inherits(AdlsSecurityException, models['AdlsRemoteException']);

/**
 * Defines the metadata of AdlsSecurityException
 *
 * @returns {object} metadata of AdlsSecurityException
 *
 */
AdlsSecurityException.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SecurityException',
    type: {
      name: 'Composite',
      className: 'AdlsSecurityException',
      modelProperties: {
        javaClassName: {
          required: false,
          readOnly: true,
          serializedName: 'javaClassName',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          readOnly: true,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        },
        exception: {
          required: true,
          serializedName: 'exception',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AdlsSecurityException;
