/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ContentSummary class.
 * @constructor
 * Data Lake Store content summary information
 *
 * @member {number} [directoryCount] the number of directories.
 * 
 * @member {number} [fileCount] the number of files.
 * 
 * @member {number} [length] the number of bytes used by the contet.
 * 
 * @member {number} [spaceConsumed] the disk space consumed by the content.
 * 
 */
function ContentSummary() {
}

/**
 * Defines the metadata of ContentSummary
 *
 * @returns {object} metadata of ContentSummary
 *
 */
ContentSummary.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ContentSummary',
    type: {
      name: 'Composite',
      className: 'ContentSummary',
      modelProperties: {
        directoryCount: {
          required: false,
          readOnly: true,
          serializedName: 'directoryCount',
          type: {
            name: 'Number'
          }
        },
        fileCount: {
          required: false,
          readOnly: true,
          serializedName: 'fileCount',
          type: {
            name: 'Number'
          }
        },
        length: {
          required: false,
          readOnly: true,
          serializedName: 'length',
          type: {
            name: 'Number'
          }
        },
        spaceConsumed: {
          required: false,
          readOnly: true,
          serializedName: 'spaceConsumed',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = ContentSummary;
