/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the FileStatuses class.
 * @constructor
 * Data Lake Store file status list information.
 *
 * @member {array} [fileStatus] the object containing the list of properties
 * of the files.
 * 
 */
function FileStatuses() {
}

/**
 * Defines the metadata of FileStatuses
 *
 * @returns {object} metadata of FileStatuses
 *
 */
FileStatuses.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'FileStatuses',
    type: {
      name: 'Composite',
      className: 'FileStatuses',
      modelProperties: {
        fileStatus: {
          required: false,
          readOnly: true,
          serializedName: 'FileStatus',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'FileStatusPropertiesElementType',
                type: {
                  name: 'Composite',
                  className: 'FileStatusProperties'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = FileStatuses;
