/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Artifact class.
 * @constructor
 * An artifact.
 * @member {string} [title] The title of the artifact.
 * 
 * @member {string} [description] The description of the artifact.
 * 
 * @member {string} [filePath] The file path of the artifact.
 * 
 * @member {string} [icon] The icon of the artifact.
 * 
 * @member {string} [targetOsType] Gets or sets the type of the target os.
 * 
 * @member {object} [parameters] The parameters of the artifact.
 * 
 * @member {string} [id] The identifier of the resource.
 * 
 * @member {string} [name] The name of the resource.
 * 
 * @member {string} [type] The type of the resource.
 * 
 * @member {string} [location] The location of the resource.
 * 
 * @member {object} [tags] The tags of the resource.
 * 
 */
function Artifact() {
  Artifact['super_'].call(this);
}

util.inherits(Artifact, models['BaseResource']);

/**
 * Defines the metadata of Artifact
 *
 * @returns {object} metadata of Artifact
 *
 */
Artifact.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Artifact',
    type: {
      name: 'Composite',
      className: 'Artifact',
      modelProperties: {
        title: {
          required: false,
          serializedName: 'properties.title',
          type: {
            name: 'String'
          }
        },
        description: {
          required: false,
          serializedName: 'properties.description',
          type: {
            name: 'String'
          }
        },
        filePath: {
          required: false,
          serializedName: 'properties.filePath',
          type: {
            name: 'String'
          }
        },
        icon: {
          required: false,
          serializedName: 'properties.icon',
          type: {
            name: 'String'
          }
        },
        targetOsType: {
          required: false,
          serializedName: 'properties.targetOsType',
          type: {
            name: 'String'
          }
        },
        parameters: {
          required: false,
          serializedName: 'properties.parameters',
          type: {
            name: 'Object'
          }
        },
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = Artifact;
