/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ArtifactDeploymentStatusProperties class.
 * @constructor
 * Properties of an artifact deployment.
 * @member {string} [deploymentStatus] The deployment status of the artifact.
 * 
 * @member {number} [artifactsApplied] The total count of the artifacts that
 * were successfully applied.
 * 
 * @member {number} [totalArtifacts] The total count of the artifacts that
 * were tentatively applied.
 * 
 */
function ArtifactDeploymentStatusProperties() {
}

/**
 * Defines the metadata of ArtifactDeploymentStatusProperties
 *
 * @returns {object} metadata of ArtifactDeploymentStatusProperties
 *
 */
ArtifactDeploymentStatusProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ArtifactDeploymentStatusProperties',
    type: {
      name: 'Composite',
      className: 'ArtifactDeploymentStatusProperties',
      modelProperties: {
        deploymentStatus: {
          required: false,
          serializedName: 'deploymentStatus',
          type: {
            name: 'String'
          }
        },
        artifactsApplied: {
          required: false,
          serializedName: 'artifactsApplied',
          type: {
            name: 'Number'
          }
        },
        totalArtifacts: {
          required: false,
          serializedName: 'totalArtifacts',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = ArtifactDeploymentStatusProperties;
