/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ArtifactSource class.
 * @constructor
 * Properties of an artifact source.
 * @member {string} [displayName] The display name of the artifact source.
 * 
 * @member {string} [uri] The URI of the artifact source.
 * 
 * @member {string} [sourceType] The type of the artifact source. Possible
 * values include: 'VsoGit', 'GitHub'
 * 
 * @member {string} [folderPath] The folder path of the artifact source.
 * 
 * @member {string} [branchRef] The branch reference of the artifact source.
 * 
 * @member {string} [securityToken] The security token of the artifact source.
 * 
 * @member {string} [status] The status of the artifact source. Possible
 * values include: 'Enabled', 'Disabled'
 * 
 * @member {string} [provisioningState] The provisioning status of the
 * resource.
 * 
 * @member {string} [id] The identifier of the resource.
 * 
 * @member {string} [name] The name of the resource.
 * 
 * @member {string} [type] The type of the resource.
 * 
 * @member {string} [location] The location of the resource.
 * 
 * @member {object} [tags] The tags of the resource.
 * 
 */
function ArtifactSource() {
  ArtifactSource['super_'].call(this);
}

util.inherits(ArtifactSource, models['BaseResource']);

/**
 * Defines the metadata of ArtifactSource
 *
 * @returns {object} metadata of ArtifactSource
 *
 */
ArtifactSource.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ArtifactSource',
    type: {
      name: 'Composite',
      className: 'ArtifactSource',
      modelProperties: {
        displayName: {
          required: false,
          serializedName: 'properties.displayName',
          type: {
            name: 'String'
          }
        },
        uri: {
          required: false,
          serializedName: 'properties.uri',
          type: {
            name: 'String'
          }
        },
        sourceType: {
          required: false,
          serializedName: 'properties.sourceType',
          type: {
            name: 'String'
          }
        },
        folderPath: {
          required: false,
          serializedName: 'properties.folderPath',
          type: {
            name: 'String'
          }
        },
        branchRef: {
          required: false,
          serializedName: 'properties.branchRef',
          type: {
            name: 'String'
          }
        },
        securityToken: {
          required: false,
          serializedName: 'properties.securityToken',
          type: {
            name: 'String'
          }
        },
        status: {
          required: false,
          serializedName: 'properties.status',
          type: {
            name: 'String'
          }
        },
        provisioningState: {
          required: false,
          serializedName: 'properties.provisioningState',
          type: {
            name: 'String'
          }
        },
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = ArtifactSource;
