/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Cost class.
 * @constructor
 * A cost item.
 * @member {string} [currencyCode] The currency code of the cost.
 * 
 * @member {array} [costs] The per-day costs items of the cost.
 * 
 * @member {string} [id] The identifier of the resource.
 * 
 * @member {string} [name] The name of the resource.
 * 
 * @member {string} [type] The type of the resource.
 * 
 * @member {string} [location] The location of the resource.
 * 
 * @member {object} [tags] The tags of the resource.
 * 
 */
function Cost() {
  Cost['super_'].call(this);
}

util.inherits(Cost, models['BaseResource']);

/**
 * Defines the metadata of Cost
 *
 * @returns {object} metadata of Cost
 *
 */
Cost.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Cost',
    type: {
      name: 'Composite',
      className: 'Cost',
      modelProperties: {
        currencyCode: {
          required: false,
          serializedName: 'properties.currencyCode',
          type: {
            name: 'String'
          }
        },
        costs: {
          required: false,
          serializedName: 'properties.costs',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'CostPerDayPropertiesElementType',
                type: {
                  name: 'Composite',
                  className: 'CostPerDayProperties'
                }
            }
          }
        },
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = Cost;
