/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the CostPerDayProperties class.
 * @constructor
 * The per-day properties of a cost item.
 * @member {date} [date] The date of the cost item.
 * 
 * @member {number} [cost] The cost of the cost item.
 * 
 * @member {string} [costType] The type of the cost. Possible values include:
 * 'Unavailable', 'Reported', 'Projected'
 * 
 */
function CostPerDayProperties() {
}

/**
 * Defines the metadata of CostPerDayProperties
 *
 * @returns {object} metadata of CostPerDayProperties
 *
 */
CostPerDayProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CostPerDayProperties',
    type: {
      name: 'Composite',
      className: 'CostPerDayProperties',
      modelProperties: {
        date: {
          required: false,
          serializedName: 'date',
          type: {
            name: 'DateTime'
          }
        },
        cost: {
          required: false,
          serializedName: 'cost',
          type: {
            name: 'Number'
          }
        },
        costType: {
          required: false,
          serializedName: 'costType',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CostPerDayProperties;
