/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the CustomImagePropertiesFromVm class.
 * @constructor
 * Properties for creating a custom image from a virtual machine.
 * @member {string} [sourceVmId] The source vm identifier.
 * 
 * @member {boolean} [sysPrep] Indicates whether sysprep has been run on the
 * VHD.
 * 
 * @member {object} [windowsOsInfo] The Windows OS information of the VM.
 * 
 * @member {string} [windowsOsInfo.windowsOsState] The state of the Windows
 * OS. Possible values include: 'NonSysprepped', 'SysprepRequested',
 * 'SysprepApplied'
 * 
 * @member {object} [linuxOsInfo] The Linux OS information of the VM.
 * 
 * @member {string} [linuxOsInfo.linuxOsState] The state of the Linux OS.
 * Possible values include: 'NonDeprovisioned', 'DeprovisionRequested',
 * 'DeprovisionApplied'
 * 
 */
function CustomImagePropertiesFromVm() {
}

/**
 * Defines the metadata of CustomImagePropertiesFromVm
 *
 * @returns {object} metadata of CustomImagePropertiesFromVm
 *
 */
CustomImagePropertiesFromVm.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CustomImagePropertiesFromVm',
    type: {
      name: 'Composite',
      className: 'CustomImagePropertiesFromVm',
      modelProperties: {
        sourceVmId: {
          required: false,
          serializedName: 'sourceVmId',
          type: {
            name: 'String'
          }
        },
        sysPrep: {
          required: false,
          serializedName: 'sysPrep',
          type: {
            name: 'Boolean'
          }
        },
        windowsOsInfo: {
          required: false,
          serializedName: 'windowsOsInfo',
          type: {
            name: 'Composite',
            className: 'WindowsOsInfo'
          }
        },
        linuxOsInfo: {
          required: false,
          serializedName: 'linuxOsInfo',
          type: {
            name: 'Composite',
            className: 'LinuxOsInfo'
          }
        }
      }
    }
  };
};

module.exports = CustomImagePropertiesFromVm;
