/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the GalleryImage class.
 * @constructor
 * A gallery image.
 * @member {string} [author] The author of the gallery image.
 * 
 * @member {date} [createdDate] The creation date of the gallery image.
 * 
 * @member {string} [description] The description of the gallery image.
 * 
 * @member {object} [imageReference] The image reference of the gallery image.
 * 
 * @member {string} [imageReference.offer] The offer of the gallery image.
 * 
 * @member {string} [imageReference.publisher] The publisher of the gallery
 * image.
 * 
 * @member {string} [imageReference.sku] The SKU of the gallery image.
 * 
 * @member {string} [imageReference.osType] The OS type of the gallery image.
 * 
 * @member {string} [imageReference.version] The version of the gallery image.
 * 
 * @member {string} [icon] The icon of the gallery image.
 * 
 * @member {boolean} [enabled] Indicates whether this gallery image is enabled.
 * 
 * @member {string} [id] The identifier of the resource.
 * 
 * @member {string} [name] The name of the resource.
 * 
 * @member {string} [type] The type of the resource.
 * 
 * @member {string} [location] The location of the resource.
 * 
 * @member {object} [tags] The tags of the resource.
 * 
 */
function GalleryImage() {
  GalleryImage['super_'].call(this);
}

util.inherits(GalleryImage, models['BaseResource']);

/**
 * Defines the metadata of GalleryImage
 *
 * @returns {object} metadata of GalleryImage
 *
 */
GalleryImage.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'GalleryImage',
    type: {
      name: 'Composite',
      className: 'GalleryImage',
      modelProperties: {
        author: {
          required: false,
          serializedName: 'properties.author',
          type: {
            name: 'String'
          }
        },
        createdDate: {
          required: false,
          serializedName: 'properties.createdDate',
          type: {
            name: 'DateTime'
          }
        },
        description: {
          required: false,
          serializedName: 'properties.description',
          type: {
            name: 'String'
          }
        },
        imageReference: {
          required: false,
          serializedName: 'properties.imageReference',
          type: {
            name: 'Composite',
            className: 'GalleryImageReference'
          }
        },
        icon: {
          required: false,
          serializedName: 'properties.icon',
          type: {
            name: 'String'
          }
        },
        enabled: {
          required: false,
          serializedName: 'properties.enabled',
          type: {
            name: 'Boolean'
          }
        },
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = GalleryImage;
