/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the GenerateArmTemplateRequest class.
 * @constructor
 * Parameters for generating an ARM template for deploying artifacts.
 * @member {string} [virtualMachineName] The resource name of the virtual
 * machine.
 * 
 * @member {array} [parameters] The parameters of the ARM template.
 * 
 * @member {string} [location] The location of the virtual machine.
 * 
 */
function GenerateArmTemplateRequest() {
}

/**
 * Defines the metadata of GenerateArmTemplateRequest
 *
 * @returns {object} metadata of GenerateArmTemplateRequest
 *
 */
GenerateArmTemplateRequest.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'GenerateArmTemplateRequest',
    type: {
      name: 'Composite',
      className: 'GenerateArmTemplateRequest',
      modelProperties: {
        virtualMachineName: {
          required: false,
          serializedName: 'virtualMachineName',
          type: {
            name: 'String'
          }
        },
        parameters: {
          required: false,
          serializedName: 'parameters',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ParameterInfoElementType',
                type: {
                  name: 'Composite',
                  className: 'ParameterInfo'
                }
            }
          }
        },
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = GenerateArmTemplateRequest;
