/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ResponseWithContinuationCustomImage class.
 * @constructor
 * The response of a list operation.
 * @member {array} [value] Results of the list operation.
 * 
 * @member {string} [nextLink] Link for next set of results.
 * 
 */
function ResponseWithContinuationCustomImage() {
}

util.inherits(ResponseWithContinuationCustomImage, Array);

/**
 * Defines the metadata of ResponseWithContinuationCustomImage
 *
 * @returns {object} metadata of ResponseWithContinuationCustomImage
 *
 */
ResponseWithContinuationCustomImage.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ResponseWithContinuation[CustomImage]',
    type: {
      name: 'Composite',
      className: 'ResponseWithContinuationCustomImage',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'CustomImageElementType',
                type: {
                  name: 'Composite',
                  className: 'CustomImage'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ResponseWithContinuationCustomImage;
