/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the SubscriptionNotification class.
 * @constructor
 * @member {string} [registrationDate]
 * 
 * @member {string} [state] Possible values include: 'NotDefined',
 * 'Registered', 'Unregistered', 'Warned', 'Suspended', 'Deleted'
 * 
 * @member {object} [properties]
 * 
 * @member {string} [properties.tenantId]
 * 
 */
function SubscriptionNotification() {
}

/**
 * Defines the metadata of SubscriptionNotification
 *
 * @returns {object} metadata of SubscriptionNotification
 *
 */
SubscriptionNotification.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SubscriptionNotification',
    type: {
      name: 'Composite',
      className: 'SubscriptionNotification',
      modelProperties: {
        registrationDate: {
          required: false,
          serializedName: 'registrationDate',
          type: {
            name: 'String'
          }
        },
        state: {
          required: false,
          serializedName: 'state',
          type: {
            name: 'String'
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'SubscriptionNotificationProperties'
          }
        }
      }
    }
  };
};

module.exports = SubscriptionNotification;
