/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the AddressSpace class.
 * @constructor
 * AddressSpace contains an array of IP address ranges that can be used by
 * subnets
 * @member {array} [addressPrefixes] Gets or sets List of address blocks
 * reserved for this virtual network in CIDR notation
 * 
 */
function AddressSpace() {
}

/**
 * Defines the metadata of AddressSpace
 *
 * @returns {object} metadata of AddressSpace
 *
 */
AddressSpace.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AddressSpace',
    type: {
      name: 'Composite',
      className: 'AddressSpace',
      modelProperties: {
        addressPrefixes: {
          required: false,
          serializedName: 'addressPrefixes',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = AddressSpace;
