/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ApplicationGatewayFrontendPort class.
 * @constructor
 * Frontend Port of application gateway
 * @member {number} [port] Gets or sets the frontend port
 * 
 * @member {string} [provisioningState] Gets or sets Provisioning state of the
 * frontend port resource Updating/Deleting/Failed
 * 
 * @member {string} [name] Gets name of the resource that is unique within a
 * resource group. This name can be used to access the resource
 * 
 * @member {string} [etag] A unique read-only string that changes whenever the
 * resource is updated
 * 
 */
function ApplicationGatewayFrontendPort() {
  ApplicationGatewayFrontendPort['super_'].call(this);
}

util.inherits(ApplicationGatewayFrontendPort, models['SubResource']);

/**
 * Defines the metadata of ApplicationGatewayFrontendPort
 *
 * @returns {object} metadata of ApplicationGatewayFrontendPort
 *
 */
ApplicationGatewayFrontendPort.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApplicationGatewayFrontendPort',
    type: {
      name: 'Composite',
      className: 'ApplicationGatewayFrontendPort',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        port: {
          required: false,
          serializedName: 'properties.port',
          type: {
            name: 'Number'
          }
        },
        provisioningState: {
          required: false,
          serializedName: 'properties.provisioningState',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        etag: {
          required: false,
          serializedName: 'etag',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ApplicationGatewayFrontendPort;
