/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ApplicationGatewaySku class.
 * @constructor
 * SKU of application gateway
 * @member {string} [name] Gets or sets name of application gateway SKU.
 * Possible values include: 'Standard_Small', 'Standard_Medium',
 * 'Standard_Large'
 * 
 * @member {string} [tier] Gets or sets tier of application gateway. Possible
 * values include: 'Standard'
 * 
 * @member {number} [capacity] Gets or sets capacity (instance count) of
 * application gateway
 * 
 */
function ApplicationGatewaySku() {
}

/**
 * Defines the metadata of ApplicationGatewaySku
 *
 * @returns {object} metadata of ApplicationGatewaySku
 *
 */
ApplicationGatewaySku.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApplicationGatewaySku',
    type: {
      name: 'Composite',
      className: 'ApplicationGatewaySku',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        tier: {
          required: false,
          serializedName: 'tier',
          type: {
            name: 'String'
          }
        },
        capacity: {
          required: false,
          serializedName: 'capacity',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = ApplicationGatewaySku;
