/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the AuthorizationListResult class.
 * @constructor
 * Response for ListAuthorizations Api service callRetrieves all
 * authorizations that belongs to an ExpressRouteCircuit
 * @member {array} [value] Gets the authorizations in an ExpressRoute Circuit
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function AuthorizationListResult() {
}

util.inherits(AuthorizationListResult, Array);

/**
 * Defines the metadata of AuthorizationListResult
 *
 * @returns {object} metadata of AuthorizationListResult
 *
 */
AuthorizationListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AuthorizationListResult',
    type: {
      name: 'Composite',
      className: 'AuthorizationListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ExpressRouteCircuitAuthorizationElementType',
                type: {
                  name: 'Composite',
                  className: 'ExpressRouteCircuitAuthorization'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AuthorizationListResult;
