/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the DhcpOptions class.
 * @constructor
 * DHCPOptions contains an array of DNS servers available to VMs deployed in
 * the virtual networkStandard DHCP option for a subnet overrides VNET DHCP
 * options.
 * @member {array} [dnsServers] Gets or sets list of DNS servers IP addresses
 * 
 */
function DhcpOptions() {
}

/**
 * Defines the metadata of DhcpOptions
 *
 * @returns {object} metadata of DhcpOptions
 *
 */
DhcpOptions.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DhcpOptions',
    type: {
      name: 'Composite',
      className: 'DhcpOptions',
      modelProperties: {
        dnsServers: {
          required: false,
          serializedName: 'dnsServers',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = DhcpOptions;
