/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ExpressRouteCircuitAuthorization class.
 * @constructor
 * Authorization in a ExpressRouteCircuit resource
 * @member {string} [authorizationKey] Gets or sets the authorization key
 * 
 * @member {string} [authorizationUseStatus] Gets or sets
 * AuthorizationUseStatus. Possible values include: 'Available', 'InUse'
 * 
 * @member {string} [provisioningState] Gets or sets Provisioning state of the
 * PublicIP resource Updating/Deleting/Failed
 * 
 * @member {string} [name] Gets name of the resource that is unique within a
 * resource group. This name can be used to access the resource
 * 
 * @member {string} [etag] A unique read-only string that changes whenever the
 * resource is updated
 * 
 */
function ExpressRouteCircuitAuthorization() {
  ExpressRouteCircuitAuthorization['super_'].call(this);
}

util.inherits(ExpressRouteCircuitAuthorization, models['SubResource']);

/**
 * Defines the metadata of ExpressRouteCircuitAuthorization
 *
 * @returns {object} metadata of ExpressRouteCircuitAuthorization
 *
 */
ExpressRouteCircuitAuthorization.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExpressRouteCircuitAuthorization',
    type: {
      name: 'Composite',
      className: 'ExpressRouteCircuitAuthorization',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        authorizationKey: {
          required: false,
          serializedName: 'properties.authorizationKey',
          type: {
            name: 'String'
          }
        },
        authorizationUseStatus: {
          required: false,
          serializedName: 'properties.authorizationUseStatus',
          type: {
            name: 'String'
          }
        },
        provisioningState: {
          required: false,
          serializedName: 'properties.provisioningState',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        etag: {
          required: false,
          serializedName: 'etag',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ExpressRouteCircuitAuthorization;
