/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ExpressRouteCircuitPeeringListResult class.
 * @constructor
 * Response for ListPeering Api service callRetrieves all Peerings that
 * belongs to an ExpressRouteCircuit
 * @member {array} [value] Gets the peerings in an express route circuit
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function ExpressRouteCircuitPeeringListResult() {
}

util.inherits(ExpressRouteCircuitPeeringListResult, Array);

/**
 * Defines the metadata of ExpressRouteCircuitPeeringListResult
 *
 * @returns {object} metadata of ExpressRouteCircuitPeeringListResult
 *
 */
ExpressRouteCircuitPeeringListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExpressRouteCircuitPeeringListResult',
    type: {
      name: 'Composite',
      className: 'ExpressRouteCircuitPeeringListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ExpressRouteCircuitPeeringElementType',
                type: {
                  name: 'Composite',
                  className: 'ExpressRouteCircuitPeering'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ExpressRouteCircuitPeeringListResult;
