/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ExpressRouteCircuitRoutesTableSummary class.
 * @constructor
 * The routes table associated with the ExpressRouteCircuit
 * @member {string} [neighbor] Neighbor.
 * 
 * @member {number} [v] BGP version number spoken to the neighbor.
 * 
 * @member {number} [as] Autonomous system number.
 * 
 * @member {string} [upDown] The length of time that the BGP session has been
 * in the Established state, or the current status if not in the Established
 * state.
 * 
 * @member {string} [statePfxRcd] Current state of the BGP session, and the
 * number of prefixes that have been received from a neighbor or peer group.
 * 
 */
function ExpressRouteCircuitRoutesTableSummary() {
}

/**
 * Defines the metadata of ExpressRouteCircuitRoutesTableSummary
 *
 * @returns {object} metadata of ExpressRouteCircuitRoutesTableSummary
 *
 */
ExpressRouteCircuitRoutesTableSummary.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExpressRouteCircuitRoutesTableSummary',
    type: {
      name: 'Composite',
      className: 'ExpressRouteCircuitRoutesTableSummary',
      modelProperties: {
        neighbor: {
          required: false,
          serializedName: 'neighbor',
          type: {
            name: 'String'
          }
        },
        v: {
          required: false,
          serializedName: 'v',
          type: {
            name: 'Number'
          }
        },
        as: {
          required: false,
          serializedName: 'as',
          type: {
            name: 'Number'
          }
        },
        upDown: {
          required: false,
          serializedName: 'upDown',
          type: {
            name: 'String'
          }
        },
        statePfxRcd: {
          required: false,
          serializedName: 'statePfxRcd',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ExpressRouteCircuitRoutesTableSummary;
