/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ExpressRouteCircuitServiceProviderProperties class.
 * @constructor
 * Contains ServiceProviderProperties in an ExpressRouteCircuit
 * @member {string} [serviceProviderName] Gets or sets serviceProviderName.
 * 
 * @member {string} [peeringLocation] Gets or sets peering location.
 * 
 * @member {number} [bandwidthInMbps] Gets or sets BandwidthInMbps.
 * 
 */
function ExpressRouteCircuitServiceProviderProperties() {
}

/**
 * Defines the metadata of ExpressRouteCircuitServiceProviderProperties
 *
 * @returns {object} metadata of ExpressRouteCircuitServiceProviderProperties
 *
 */
ExpressRouteCircuitServiceProviderProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExpressRouteCircuitServiceProviderProperties',
    type: {
      name: 'Composite',
      className: 'ExpressRouteCircuitServiceProviderProperties',
      modelProperties: {
        serviceProviderName: {
          required: false,
          serializedName: 'serviceProviderName',
          type: {
            name: 'String'
          }
        },
        peeringLocation: {
          required: false,
          serializedName: 'peeringLocation',
          type: {
            name: 'String'
          }
        },
        bandwidthInMbps: {
          required: false,
          serializedName: 'bandwidthInMbps',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = ExpressRouteCircuitServiceProviderProperties;
