/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ExpressRouteCircuitSku class.
 * @constructor
 * Contains sku in an ExpressRouteCircuit
 * @member {string} [name] Gets or sets name of the sku.
 * 
 * @member {string} [tier] Gets or sets tier of the sku. Possible values
 * include: 'Standard', 'Premium'
 * 
 * @member {string} [family] Gets or sets family of the sku. Possible values
 * include: 'UnlimitedData', 'MeteredData'
 * 
 */
function ExpressRouteCircuitSku() {
}

/**
 * Defines the metadata of ExpressRouteCircuitSku
 *
 * @returns {object} metadata of ExpressRouteCircuitSku
 *
 */
ExpressRouteCircuitSku.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExpressRouteCircuitSku',
    type: {
      name: 'Composite',
      className: 'ExpressRouteCircuitSku',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        tier: {
          required: false,
          serializedName: 'tier',
          type: {
            name: 'String'
          }
        },
        family: {
          required: false,
          serializedName: 'family',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ExpressRouteCircuitSku;
