/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ExpressRouteCircuitsArpTableListResult class.
 * @constructor
 * Response for ListArpTable associated with the Express Route Circuits Api
 * @member {array} [value] Gets List of ArpTable
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function ExpressRouteCircuitsArpTableListResult() {
}

/**
 * Defines the metadata of ExpressRouteCircuitsArpTableListResult
 *
 * @returns {object} metadata of ExpressRouteCircuitsArpTableListResult
 *
 */
ExpressRouteCircuitsArpTableListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExpressRouteCircuitsArpTableListResult',
    type: {
      name: 'Composite',
      className: 'ExpressRouteCircuitsArpTableListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: 'value',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ExpressRouteCircuitArpTableElementType',
                type: {
                  name: 'Composite',
                  className: 'ExpressRouteCircuitArpTable'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ExpressRouteCircuitsArpTableListResult;
