/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the LocalNetworkGatewayListResult class.
 * @constructor
 * Response for ListLocalNetworkGateways Api service call
 * @member {array} [value] Gets List of LocalNetworkGateways that exists in a
 * resource group
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function LocalNetworkGatewayListResult() {
}

util.inherits(LocalNetworkGatewayListResult, Array);

/**
 * Defines the metadata of LocalNetworkGatewayListResult
 *
 * @returns {object} metadata of LocalNetworkGatewayListResult
 *
 */
LocalNetworkGatewayListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'LocalNetworkGatewayListResult',
    type: {
      name: 'Composite',
      className: 'LocalNetworkGatewayListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'LocalNetworkGatewayElementType',
                type: {
                  name: 'Composite',
                  className: 'LocalNetworkGateway'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = LocalNetworkGatewayListResult;
