/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the PublicIPAddressDnsSettings class.
 * @constructor
 * Contains FQDN of the DNS record associated with the public IP address
 * @member {string} [domainNameLabel] Gets or sets the Domain name label.The
 * concatenation of the domain name label and the regionalized DNS zone make
 * up the fully qualified domain name associated with the public IP address.
 * If a domain name label is specified, an A DNS record is created for the
 * public IP in the Microsoft Azure DNS system.
 * 
 * @member {string} [fqdn] Gets the FQDN, Fully qualified domain name of the A
 * DNS record associated with the public IP. This is the concatenation of the
 * domainNameLabel and the regionalized DNS zone.
 * 
 * @member {string} [reverseFqdn] Gets or Sests the Reverse FQDN. A
 * user-visible, fully qualified domain name that resolves to this public IP
 * address. If the reverseFqdn is specified, then a PTR DNS record is created
 * pointing from the IP address in the in-addr.arpa domain to the reverse
 * FQDN.
 * 
 */
function PublicIPAddressDnsSettings() {
}

/**
 * Defines the metadata of PublicIPAddressDnsSettings
 *
 * @returns {object} metadata of PublicIPAddressDnsSettings
 *
 */
PublicIPAddressDnsSettings.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'PublicIPAddressDnsSettings',
    type: {
      name: 'Composite',
      className: 'PublicIPAddressDnsSettings',
      modelProperties: {
        domainNameLabel: {
          required: false,
          serializedName: 'domainNameLabel',
          type: {
            name: 'String'
          }
        },
        fqdn: {
          required: false,
          serializedName: 'fqdn',
          type: {
            name: 'String'
          }
        },
        reverseFqdn: {
          required: false,
          serializedName: 'reverseFqdn',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = PublicIPAddressDnsSettings;
