/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the RouteListResult class.
 * @constructor
 * Response for ListRoute Api servive call
 * @member {array} [value] Gets List of Routes in a resource group
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function RouteListResult() {
}

util.inherits(RouteListResult, Array);

/**
 * Defines the metadata of RouteListResult
 *
 * @returns {object} metadata of RouteListResult
 *
 */
RouteListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'RouteListResult',
    type: {
      name: 'Composite',
      className: 'RouteListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'RouteElementType',
                type: {
                  name: 'Composite',
                  className: 'Route'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = RouteListResult;
