/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SecurityRuleListResult class.
 * @constructor
 * Response for ListSecurityRule Api service callRetrieves all security rules
 * that belongs to a network security group
 * @member {array} [value] Gets security rules in a network security group
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function SecurityRuleListResult() {
}

util.inherits(SecurityRuleListResult, Array);

/**
 * Defines the metadata of SecurityRuleListResult
 *
 * @returns {object} metadata of SecurityRuleListResult
 *
 */
SecurityRuleListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SecurityRuleListResult',
    type: {
      name: 'Composite',
      className: 'SecurityRuleListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'SecurityRuleElementType',
                type: {
                  name: 'Composite',
                  className: 'SecurityRule'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = SecurityRuleListResult;
