/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VirtualNetworkGatewayConnectionListResult class.
 * @constructor
 * Response for ListVirtualNetworkGatewayConnections Api service call
 * @member {array} [value] Gets List of VirtualNetworkGatewayConnections that
 * exists in a resource group
 * 
 * @member {string} [nextLink] Gets the URL to get the next set of results.
 * 
 */
function VirtualNetworkGatewayConnectionListResult() {
}

util.inherits(VirtualNetworkGatewayConnectionListResult, Array);

/**
 * Defines the metadata of VirtualNetworkGatewayConnectionListResult
 *
 * @returns {object} metadata of VirtualNetworkGatewayConnectionListResult
 *
 */
VirtualNetworkGatewayConnectionListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VirtualNetworkGatewayConnectionListResult',
    type: {
      name: 'Composite',
      className: 'VirtualNetworkGatewayConnectionListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'VirtualNetworkGatewayConnectionElementType',
                type: {
                  name: 'Composite',
                  className: 'VirtualNetworkGatewayConnection'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = VirtualNetworkGatewayConnectionListResult;
