/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the VpnClientRevokedCertificate class.
 * @constructor
 * VPN client revoked certificate of virtual network gateway
 * @member {string} [thumbprint] Gets or sets the revoked Vpn client
 * certificate thumbprint
 * 
 * @member {string} [provisioningState] Gets or sets Provisioning state of the
 * VPN client revoked certificate resource Updating/Deleting/Failed
 * 
 * @member {string} [name] Gets name of the resource that is unique within a
 * resource group. This name can be used to access the resource
 * 
 * @member {string} [etag] A unique read-only string that changes whenever the
 * resource is updated
 * 
 */
function VpnClientRevokedCertificate() {
  VpnClientRevokedCertificate['super_'].call(this);
}

util.inherits(VpnClientRevokedCertificate, models['SubResource']);

/**
 * Defines the metadata of VpnClientRevokedCertificate
 *
 * @returns {object} metadata of VpnClientRevokedCertificate
 *
 */
VpnClientRevokedCertificate.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'VpnClientRevokedCertificate',
    type: {
      name: 'Composite',
      className: 'VpnClientRevokedCertificate',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        thumbprint: {
          required: false,
          serializedName: 'properties.thumbprint',
          type: {
            name: 'String'
          }
        },
        provisioningState: {
          required: false,
          serializedName: 'properties.provisioningState',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        etag: {
          required: false,
          serializedName: 'etag',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = VpnClientRevokedCertificate;
