/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the CheckNameResponse class.
 * @constructor
 * @member {boolean} [nameAvailable] Specifies a Boolean value that indicates
 * whether the specified Power BI Workspace Collection name is available to
 * use.
 * 
 * @member {string} [reason] Reason why the workspace collection name cannot
 * be used. Possible values include: 'Unavailable', 'Invalid'
 * 
 * @member {string} [message] Message indicating an unavailable name due to a
 * conflict or a description of the naming rules that are violated.
 * 
 */
function CheckNameResponse() {
}

/**
 * Defines the metadata of CheckNameResponse
 *
 * @returns {object} metadata of CheckNameResponse
 *
 */
CheckNameResponse.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CheckNameResponse',
    type: {
      name: 'Composite',
      className: 'CheckNameResponse',
      modelProperties: {
        nameAvailable: {
          required: false,
          serializedName: 'nameAvailable',
          type: {
            name: 'Boolean'
          }
        },
        reason: {
          required: false,
          serializedName: 'reason',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CheckNameResponse;
