/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the RedisListKeysResult class.
 * @constructor
 * The response of redis list keys operation.
 * @member {string} [primaryKey] The current primary key that clients can use
 * to authenticate with redis cache.
 * 
 * @member {string} [secondaryKey] The current secondary key that clients can
 * use to authenticate with redis cache.
 * 
 */
function RedisListKeysResult() {
}

/**
 * Defines the metadata of RedisListKeysResult
 *
 * @returns {object} metadata of RedisListKeysResult
 *
 */
RedisListKeysResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'RedisListKeysResult',
    type: {
      name: 'Composite',
      className: 'RedisListKeysResult',
      modelProperties: {
        primaryKey: {
          required: false,
          serializedName: 'primaryKey',
          type: {
            name: 'String'
          }
        },
        secondaryKey: {
          required: false,
          serializedName: 'secondaryKey',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = RedisListKeysResult;
