/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the RedisListResult class.
 * @constructor
 * The response of list redis operation.
 * @member {array} [value] Results of the list operation
 * 
 * @member {string} [nextLink] Link for next set of locations.
 * 
 */
function RedisListResult() {
}

util.inherits(RedisListResult, Array);

/**
 * Defines the metadata of RedisListResult
 *
 * @returns {object} metadata of RedisListResult
 *
 */
RedisListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'RedisListResult',
    type: {
      name: 'Composite',
      className: 'RedisListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'RedisResourceElementType',
                type: {
                  name: 'Composite',
                  className: 'RedisResource'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = RedisListResult;
