/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.15.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Sku class.
 * @constructor
 * Sku parameters supplied to the create redis operation.
 * @member {string} name What type of redis cache to deploy. Valid values:
 * (Basic, Standard, Premium). Possible values include: 'Basic', 'Standard',
 * 'Premium'
 * 
 * @member {string} family Which family to use. Valid values: (C, P). Possible
 * values include: 'C', 'P'
 * 
 * @member {number} capacity What size of redis cache to deploy. Valid values:
 * for C family (0, 1, 2, 3, 4, 5, 6), for P family (1, 2, 3, 4)
 * 
 */
function Sku() {
}

/**
 * Defines the metadata of Sku
 *
 * @returns {object} metadata of Sku
 *
 */
Sku.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Sku',
    type: {
      name: 'Composite',
      className: 'Sku',
      modelProperties: {
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        family: {
          required: true,
          serializedName: 'family',
          type: {
            name: 'String'
          }
        },
        capacity: {
          required: true,
          serializedName: 'capacity',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = Sku;
