/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the FeatureResult class.
 * @constructor
 * Previewed feature information.
 * @member {string} [name] Gets or sets the name of the feature.
 * 
 * @member {object} [properties] Gets or sets the properties of the previewed
 * feature.
 * 
 * @member {string} [properties.state] Gets or sets the state of the previewed
 * feature.
 * 
 * @member {string} [id] Gets or sets the Id of the feature.
 * 
 * @member {string} [type] Gets or sets the type of the feature.
 * 
 */
function FeatureResult() {
}

/**
 * Defines the metadata of FeatureResult
 *
 * @returns {object} metadata of FeatureResult
 *
 */
FeatureResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'FeatureResult',
    type: {
      name: 'Composite',
      className: 'FeatureResult',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'FeatureProperties'
          }
        },
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = FeatureResult;
