/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the DeploymentListResult class.
 * @constructor
 * List of deployments.
 * @member {array} [value] The list of deployments.
 * 
 * @member {string} [nextLink] The URL to get the next set of results.
 * 
 */
function DeploymentListResult() {
}

util.inherits(DeploymentListResult, Array);

/**
 * Defines the metadata of DeploymentListResult
 *
 * @returns {object} metadata of DeploymentListResult
 *
 */
DeploymentListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DeploymentListResult',
    type: {
      name: 'Composite',
      className: 'DeploymentListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'DeploymentExtendedElementType',
                type: {
                  name: 'Composite',
                  className: 'DeploymentExtended'
                }
            }
          }
        },
        nextLink: {
          required: false,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = DeploymentListResult;
