/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Identity class.
 * @constructor
 * Identity for the resource.
 *
 * @member {string} [principalId] The principal id of resource identity.
 * 
 * @member {string} [tenantId] The tenant id of resource.
 * 
 * @member {string} [type] The identity type. Possible values include:
 * 'SystemAssigned'
 * 
 */
function Identity() {
}

/**
 * Defines the metadata of Identity
 *
 * @returns {object} metadata of Identity
 *
 */
Identity.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Identity',
    type: {
      name: 'Composite',
      className: 'Identity',
      modelProperties: {
        principalId: {
          required: false,
          readOnly: true,
          serializedName: 'principalId',
          type: {
            name: 'String'
          }
        },
        tenantId: {
          required: false,
          readOnly: true,
          serializedName: 'tenantId',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'Enum',
            allowedValues: [ 'SystemAssigned' ]
          }
        }
      }
    }
  };
};

module.exports = Identity;
