/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ProviderResourceType class.
 * @constructor
 * Resource type managed by the resource provider.
 *
 * @member {string} [resourceType] The resource type.
 * 
 * @member {array} [locations] The collection of locations where this resource
 * type can be created in.
 * 
 * @member {array} [aliases] The aliases that are supported by this resource
 * type.
 * 
 * @member {array} [apiVersions] The api version.
 * 
 * @member {object} [properties] The properties.
 * 
 */
function ProviderResourceType() {
}

/**
 * Defines the metadata of ProviderResourceType
 *
 * @returns {object} metadata of ProviderResourceType
 *
 */
ProviderResourceType.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ProviderResourceType',
    type: {
      name: 'Composite',
      className: 'ProviderResourceType',
      modelProperties: {
        resourceType: {
          required: false,
          serializedName: 'resourceType',
          type: {
            name: 'String'
          }
        },
        locations: {
          required: false,
          serializedName: 'locations',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        aliases: {
          required: false,
          serializedName: 'aliases',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'AliasTypeElementType',
                type: {
                  name: 'Composite',
                  className: 'AliasType'
                }
            }
          }
        },
        apiVersions: {
          required: false,
          serializedName: 'apiVersions',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = ProviderResourceType;
