/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the ResourceGroupExportResult class.
 * @constructor
 * @member {object} [template] The template content.
 * 
 * @member {object} [error] The error.
 * 
 * @member {string} [error.code] The error code returned from the server.
 * 
 * @member {string} [error.message] The error message returned from the server.
 * 
 * @member {string} [error.target] The target of the error.
 * 
 * @member {array} [error.details] Validation error.
 * 
 */
function ResourceGroupExportResult() {
}

/**
 * Defines the metadata of ResourceGroupExportResult
 *
 * @returns {object} metadata of ResourceGroupExportResult
 *
 */
ResourceGroupExportResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ResourceGroupExportResult',
    type: {
      name: 'Composite',
      className: 'ResourceGroupExportResult',
      modelProperties: {
        template: {
          required: false,
          serializedName: 'template',
          type: {
            name: 'Object'
          }
        },
        error: {
          required: false,
          serializedName: 'error',
          type: {
            name: 'Composite',
            className: 'ResourceManagementErrorWithDetails'
          }
        }
      }
    }
  };
};

module.exports = ResourceGroupExportResult;
