/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ResourceListResult class.
 * @constructor
 * List of resource groups.
 * @member {array} [value] The list of resources.
 * 
 * @member {string} nextLink The URL to get the next set of results.
 * 
 */
function ResourceListResult() {
}

util.inherits(ResourceListResult, Array);

/**
 * Defines the metadata of ResourceListResult
 *
 * @returns {object} metadata of ResourceListResult
 *
 */
ResourceListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ResourceListResult',
    type: {
      name: 'Composite',
      className: 'ResourceListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'GenericResourceElementType',
                type: {
                  name: 'Composite',
                  className: 'GenericResource'
                }
            }
          }
        },
        nextLink: {
          required: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ResourceListResult;
