/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ResourcesMoveInfo class.
 * @constructor
 * Parameters of move resources.
 *
 * @member {array} [resources] The ids of the resources.
 * 
 * @member {string} [targetResourceGroup] The target resource group.
 * 
 */
function ResourcesMoveInfo() {
}

/**
 * Defines the metadata of ResourcesMoveInfo
 *
 * @returns {object} metadata of ResourcesMoveInfo
 *
 */
ResourcesMoveInfo.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ResourcesMoveInfo',
    type: {
      name: 'Composite',
      className: 'ResourcesMoveInfo',
      modelProperties: {
        resources: {
          required: false,
          serializedName: 'resources',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        targetResourceGroup: {
          required: false,
          serializedName: 'targetResourceGroup',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ResourcesMoveInfo;
