/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Sku class.
 * @constructor
 * Sku for the resource.
 *
 * @member {string} [name] The sku name.
 * 
 * @member {string} [tier] The sku tier.
 * 
 * @member {string} [size] The sku size.
 * 
 * @member {string} [family] The sku family.
 * 
 * @member {string} [model] The sku model.
 * 
 * @member {number} [capacity] The sku capacity.
 * 
 */
function Sku() {
}

/**
 * Defines the metadata of Sku
 *
 * @returns {object} metadata of Sku
 *
 */
Sku.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Sku',
    type: {
      name: 'Composite',
      className: 'Sku',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        tier: {
          required: false,
          serializedName: 'tier',
          type: {
            name: 'String'
          }
        },
        size: {
          required: false,
          serializedName: 'size',
          type: {
            name: 'String'
          }
        },
        family: {
          required: false,
          serializedName: 'family',
          type: {
            name: 'String'
          }
        },
        model: {
          required: false,
          serializedName: 'model',
          type: {
            name: 'String'
          }
        },
        capacity: {
          required: false,
          serializedName: 'capacity',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = Sku;
