/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the TemplateLink class.
 * @constructor
 * Entity representing the reference to the template.
 *
 * @member {string} uri URI referencing the template.
 * 
 * @member {string} [contentVersion] If included it must match the
 * ContentVersion in the template.
 * 
 */
function TemplateLink() {
}

/**
 * Defines the metadata of TemplateLink
 *
 * @returns {object} metadata of TemplateLink
 *
 */
TemplateLink.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TemplateLink',
    type: {
      name: 'Composite',
      className: 'TemplateLink',
      modelProperties: {
        uri: {
          required: true,
          serializedName: 'uri',
          type: {
            name: 'String'
          }
        },
        contentVersion: {
          required: false,
          serializedName: 'contentVersion',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = TemplateLink;
