/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Location class.
 * @constructor
 * Location information.
 *
 * @member {string} [id] Gets or sets the ID of the resource
 * (/subscriptions/SubscriptionId).
 * 
 * @member {string} [subscriptionId] Gets or sets the subscription Id.
 * 
 * @member {string} [name] Gets or sets the location name
 * 
 * @member {string} [displayName] Gets or sets the display name of the location
 * 
 * @member {string} [latitude] Gets or sets the latitude of the location
 * 
 * @member {string} [longitude] Gets or sets the longitude of the location
 * 
 */
function Location() {
}

/**
 * Defines the metadata of Location
 *
 * @returns {object} metadata of Location
 *
 */
Location.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Location',
    type: {
      name: 'Composite',
      className: 'Location',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        subscriptionId: {
          required: false,
          serializedName: 'subscriptionId',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        displayName: {
          required: false,
          serializedName: 'displayName',
          type: {
            name: 'String'
          }
        },
        latitude: {
          required: false,
          serializedName: 'latitude',
          type: {
            name: 'String'
          }
        },
        longitude: {
          required: false,
          serializedName: 'longitude',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = Location;
