/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SubscriptionListResult class.
 * @constructor
 * Subscription list operation response.
 * @member {array} [value] Gets or sets subscriptions.
 * 
 * @member {string} nextLink Gets or sets the URL to get the next set of
 * results.
 * 
 */
function SubscriptionListResult() {
}

util.inherits(SubscriptionListResult, Array);

/**
 * Defines the metadata of SubscriptionListResult
 *
 * @returns {object} metadata of SubscriptionListResult
 *
 */
SubscriptionListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SubscriptionListResult',
    type: {
      name: 'Composite',
      className: 'SubscriptionListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'SubscriptionElementType',
                type: {
                  name: 'Composite',
                  className: 'Subscription'
                }
            }
          }
        },
        nextLink: {
          required: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = SubscriptionListResult;
