/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the GatewayParameters class.
 * @constructor
 * @member {string} [location] location of the resource
 * 
 * @member {object} [tags] resource tags
 * 
 * @member {string} [autoUpgrade] The autoUpgrade property gives the
 * flexibility to gateway to auto upgrade itself. If properties value not
 * specified, then we assume autoUpgrade = Off. Possible values include:
 * 'On', 'Off'
 * 
 */
function GatewayParameters() {
}

/**
 * Defines the metadata of GatewayParameters
 *
 * @returns {object} metadata of GatewayParameters
 *
 */
GatewayParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'GatewayParameters',
    type: {
      name: 'Composite',
      className: 'GatewayParameters',
      modelProperties: {
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Object'
          }
        },
        autoUpgrade: {
          required: false,
          serializedName: 'properties.autoUpgrade',
          type: {
            name: 'Enum',
            allowedValues: [ 'On', 'Off' ]
          }
        }
      }
    }
  };
};

module.exports = GatewayParameters;
