/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the PowerShellCommandResult class.
 * @constructor
 * @member {number} [messageType] the type of message
 * 
 * @member {string} [foregroundColor] the HTML color string representing the
 * foreground color.
 * 
 * @member {string} [backgroundColor] the HTML color string representing the
 * background color.
 * 
 * @member {string} [value] actual result text from the PowerShell Command
 * 
 * @member {string} [prompt] The interactive prompt message
 * 
 * @member {number} [exitCode] the exit code from a executable that was called
 * from powershell.
 * 
 * @member {number} [id] ID of the prompt message
 * 
 * @member {string} [caption] text that precedes the prompt.
 * 
 * @member {string} [message] text of the prompt.
 * 
 * @member {array} [descriptions] collection of PromptFieldDescription objects
 * that contains the user input
 * 
 */
function PowerShellCommandResult() {
}

/**
 * Defines the metadata of PowerShellCommandResult
 *
 * @returns {object} metadata of PowerShellCommandResult
 *
 */
PowerShellCommandResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'PowerShellCommandResult',
    type: {
      name: 'Composite',
      className: 'PowerShellCommandResult',
      modelProperties: {
        messageType: {
          required: false,
          serializedName: 'messageType',
          type: {
            name: 'Number'
          }
        },
        foregroundColor: {
          required: false,
          serializedName: 'foregroundColor',
          type: {
            name: 'String'
          }
        },
        backgroundColor: {
          required: false,
          serializedName: 'backgroundColor',
          type: {
            name: 'String'
          }
        },
        value: {
          required: false,
          serializedName: 'value',
          type: {
            name: 'String'
          }
        },
        prompt: {
          required: false,
          serializedName: 'prompt',
          type: {
            name: 'String'
          }
        },
        exitCode: {
          required: false,
          serializedName: 'exitCode',
          type: {
            name: 'Number'
          }
        },
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'Number'
          }
        },
        caption: {
          required: false,
          serializedName: 'caption',
          type: {
            name: 'String'
          }
        },
        message: {
          required: false,
          serializedName: 'message',
          type: {
            name: 'String'
          }
        },
        descriptions: {
          required: false,
          serializedName: 'descriptions',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'PromptFieldDescriptionElementType',
                type: {
                  name: 'Composite',
                  className: 'PromptFieldDescription'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = PowerShellCommandResult;
