/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the PromptFieldDescription class.
 * @constructor
 * Field description for the implementation of PSHostUserInterface.Prompt
 * @member {string} [name] the name of the prompt
 * 
 * @member {string} [label] the label text of the prompt
 * 
 * @member {string} [helpMessage] the help message of the prompt
 * 
 * @member {boolean} [promptFieldTypeIsList] when set to 'true' the prompt
 * field type is a list of values
 * 
 * @member {string} [promptFieldType] Possible values include: 'String',
 * 'SecureString', 'Credential'
 * 
 */
function PromptFieldDescription() {
}

/**
 * Defines the metadata of PromptFieldDescription
 *
 * @returns {object} metadata of PromptFieldDescription
 *
 */
PromptFieldDescription.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'PromptFieldDescription',
    type: {
      name: 'Composite',
      className: 'PromptFieldDescription',
      modelProperties: {
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        label: {
          required: false,
          serializedName: 'label',
          type: {
            name: 'String'
          }
        },
        helpMessage: {
          required: false,
          serializedName: 'helpMessage',
          type: {
            name: 'String'
          }
        },
        promptFieldTypeIsList: {
          required: false,
          serializedName: 'promptFieldTypeIsList',
          type: {
            name: 'Boolean'
          }
        },
        promptFieldType: {
          required: false,
          serializedName: 'promptFieldType',
          type: {
            name: 'Enum',
            allowedValues: [ 'String', 'SecureString', 'Credential' ]
          }
        }
      }
    }
  };
};

module.exports = PromptFieldDescription;
