/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SessionResource class.
 * @constructor
 * the session object
 * @member {string} [userName] the username connecting to the session
 * 
 * @member {date} [created] UTC date and time when node was first added to
 * management service
 * 
 * @member {date} [updated] UTC date and time when node was last updated.
 * 
 */
function SessionResource() {
  SessionResource['super_'].call(this);
}

util.inherits(SessionResource, models['Resource']);

/**
 * Defines the metadata of SessionResource
 *
 * @returns {object} metadata of SessionResource
 *
 */
SessionResource.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SessionResource',
    type: {
      name: 'Composite',
      className: 'SessionResource',
      modelProperties: {
        id: {
          required: false,
          readOnly: true,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          readOnly: true,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          readOnly: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        location: {
          required: false,
          readOnly: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        etag: {
          required: false,
          serializedName: 'etag',
          type: {
            name: 'String'
          }
        },
        userName: {
          required: false,
          serializedName: 'properties.userName',
          type: {
            name: 'String'
          }
        },
        created: {
          required: false,
          serializedName: 'properties.created',
          type: {
            name: 'DateTime'
          }
        },
        updated: {
          required: false,
          serializedName: 'properties.updated',
          type: {
            name: 'DateTime'
          }
        }
      }
    }
  };
};

module.exports = SessionResource;
