/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Version class.
 * @constructor
 * A multipart-numeric version number
 * @member {number} [major] the leftmost number of the version
 * 
 * @member {number} [minor] the second leftmost number of the version
 * 
 * @member {number} [build] the third number of the version
 * 
 * @member {number} [revision] the fourth number of the version
 * 
 * @member {number} [majorRevision] the MSW of the fourth part
 * 
 * @member {number} [minorRevision] the LSW of the fourth part
 * 
 */
function Version() {
}

/**
 * Defines the metadata of Version
 *
 * @returns {object} metadata of Version
 *
 */
Version.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Version',
    type: {
      name: 'Composite',
      className: 'Version',
      modelProperties: {
        major: {
          required: false,
          serializedName: 'major',
          type: {
            name: 'Number'
          }
        },
        minor: {
          required: false,
          serializedName: 'minor',
          type: {
            name: 'Number'
          }
        },
        build: {
          required: false,
          serializedName: 'build',
          type: {
            name: 'Number'
          }
        },
        revision: {
          required: false,
          serializedName: 'revision',
          type: {
            name: 'Number'
          }
        },
        majorRevision: {
          required: false,
          serializedName: 'majorRevision',
          type: {
            name: 'Number'
          }
        },
        minorRevision: {
          required: false,
          serializedName: 'minorRevision',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = Version;
