/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Sku class.
 * @constructor
 * The SKU of the storage account.
 * @member {string} name Gets or sets the sku name. Required for account
 * creation, optional for update. Note that in older versions, sku name was
 * called accountType. Possible values include: 'Standard_LRS',
 * 'Standard_GRS', 'Standard_RAGRS', 'Standard_ZRS', 'Premium_LRS'
 * 
 * @member {string} [tier] Gets the sku tier. This is based on the SKU name.
 * Possible values include: 'Standard', 'Premium'
 * 
 */
function Sku() {
}

/**
 * Defines the metadata of Sku
 *
 * @returns {object} metadata of Sku
 *
 */
Sku.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Sku',
    type: {
      name: 'Composite',
      className: 'Sku',
      modelProperties: {
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'Enum',
            allowedValues: [ 'Standard_LRS', 'Standard_GRS', 'Standard_RAGRS', 'Standard_ZRS', 'Premium_LRS' ]
          }
        },
        tier: {
          required: false,
          readOnly: true,
          serializedName: 'tier',
          type: {
            name: 'Enum',
            allowedValues: [ 'Standard', 'Premium' ]
          }
        }
      }
    }
  };
};

module.exports = Sku;
