/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the StorageAccountKey class.
 * @constructor
 * An access key for the storage account.
 * @member {string} [keyName] Name of the key.
 * 
 * @member {string} [value] Base 64 encoded value of the key.
 * 
 * @member {string} [permissions] Permissions for the key. Possible values
 * include: 'READ', 'FULL'
 * 
 */
function StorageAccountKey() {
}

/**
 * Defines the metadata of StorageAccountKey
 *
 * @returns {object} metadata of StorageAccountKey
 *
 */
StorageAccountKey.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'StorageAccountKey',
    type: {
      name: 'Composite',
      className: 'StorageAccountKey',
      modelProperties: {
        keyName: {
          required: false,
          readOnly: true,
          serializedName: 'keyName',
          type: {
            name: 'String'
          }
        },
        value: {
          required: false,
          readOnly: true,
          serializedName: 'value',
          type: {
            name: 'String'
          }
        },
        permissions: {
          required: false,
          readOnly: true,
          serializedName: 'permissions',
          type: {
            name: 'Enum',
            allowedValues: [ 'READ', 'FULL' ]
          }
        }
      }
    }
  };
};

module.exports = StorageAccountKey;
