/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the AccountListNodeAgentSkusNextOptions class.
 * @constructor
 * Additional parameters for the listNodeAgentSkusNext operation.
 * @member {string} [clientRequestId] The caller-generated request identity,
 * in the form of a GUID with no decoration such as curly braces, e.g.
 * 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0.
 * 
 * @member {boolean} [returnClientRequestId] Whether the server should return
 * the client-request-id identifier in the response.
 * 
 * @member {date} [ocpDate] The time the request was issued. If not specified,
 * this header will be automatically populated with the current system clock
 * time.
 * 
 */
function AccountListNodeAgentSkusNextOptions() {
}

/**
 * Defines the metadata of AccountListNodeAgentSkusNextOptions
 *
 * @returns {object} metadata of AccountListNodeAgentSkusNextOptions
 *
 */
AccountListNodeAgentSkusNextOptions.prototype.mapper = function () {
  return {
    required: false,
    type: {
      name: 'Composite',
      className: 'AccountListNodeAgentSkusNextOptions',
      modelProperties: {
        clientRequestId: {
          required: false,
          type: {
            name: 'String'
          }
        },
        returnClientRequestId: {
          required: false,
          type: {
            name: 'Boolean'
          }
        },
        ocpDate: {
          required: false,
          type: {
            name: 'DateTimeRfc1123'
          }
        }
      }
    }
  };
};

module.exports = AccountListNodeAgentSkusNextOptions;
