/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ApplicationListResult class.
 * @constructor
 * Response to a ApplicationOperations.List request.
 * @member {array} [value] The list of applications available in the account.
 * 
 * @member {string} [odatanextLink] The URL to get the next set of results.
 * 
 */
function ApplicationListResult() {
}

util.inherits(ApplicationListResult, Array);

/**
 * Defines the metadata of ApplicationListResult
 *
 * @returns {object} metadata of ApplicationListResult
 *
 */
ApplicationListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApplicationListResult',
    type: {
      name: 'Composite',
      className: 'ApplicationListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ApplicationSummaryElementType',
                type: {
                  name: 'Composite',
                  className: 'ApplicationSummary'
                }
            }
          }
        },
        odatanextLink: {
          required: false,
          serializedName: 'odata\\.nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ApplicationListResult;
