/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the BatchErrorDetail class.
 * @constructor
 * An item of additional information included in an Azure Batch error response.
 * @member {string} [key] An identifier specifying the meaning of the Value
 * property.
 * 
 * @member {string} [value] The additional information included with the error
 * response.
 * 
 */
function BatchErrorDetail() {
}

/**
 * Defines the metadata of BatchErrorDetail
 *
 * @returns {object} metadata of BatchErrorDetail
 *
 */
BatchErrorDetail.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'BatchErrorDetail',
    type: {
      name: 'Composite',
      className: 'BatchErrorDetail',
      modelProperties: {
        key: {
          required: false,
          serializedName: 'key',
          type: {
            name: 'String'
          }
        },
        value: {
          required: false,
          serializedName: 'value',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = BatchErrorDetail;
