/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the CloudJobListPreparationAndReleaseTaskStatusResult class.
 * @constructor
 * Response to a CloudJobOperations.ListPreparationAndReleaseTaskStatus
 * request.
 * @member {array} [value] A list of Job Preparation and Job Release task
 * execution information.
 * 
 * @member {string} [odatanextLink] The URL to get the next set of results.
 * 
 */
function CloudJobListPreparationAndReleaseTaskStatusResult() {
}

util.inherits(CloudJobListPreparationAndReleaseTaskStatusResult, Array);

/**
 * Defines the metadata of CloudJobListPreparationAndReleaseTaskStatusResult
 *
 * @returns {object} metadata of CloudJobListPreparationAndReleaseTaskStatusResult
 *
 */
CloudJobListPreparationAndReleaseTaskStatusResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CloudJobListPreparationAndReleaseTaskStatusResult',
    type: {
      name: 'Composite',
      className: 'CloudJobListPreparationAndReleaseTaskStatusResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'JobPreparationAndReleaseTaskExecutionInformationElementType',
                type: {
                  name: 'Composite',
                  className: 'JobPreparationAndReleaseTaskExecutionInformation'
                }
            }
          }
        },
        odatanextLink: {
          required: false,
          serializedName: 'odata\\.nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CloudJobListPreparationAndReleaseTaskStatusResult;
