/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the CloudServiceConfiguration class.
 * @constructor
 * The configuration for nodes in a pool based on the Azure Cloud Services
 * platform.
 * @member {string} osFamily The Azure Guest OS family to be installed on the
 * virtual machines in the pool.
 * 
 * @member {string} [targetOSVersion] The Azure Guest OS version to be
 * installed on the virtual machines in the pool. The default value is *
 * which specifies the latest operating system version for the specified OS
 * family.
 * 
 * @member {string} [currentOSVersion] The Azure Guest OS Version currently
 * installed on the virtual machines in the pool. This may differ from
 * TargetOSVersion if the pool state is Upgrading.
 * 
 */
function CloudServiceConfiguration() {
}

/**
 * Defines the metadata of CloudServiceConfiguration
 *
 * @returns {object} metadata of CloudServiceConfiguration
 *
 */
CloudServiceConfiguration.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'CloudServiceConfiguration',
    type: {
      name: 'Composite',
      className: 'CloudServiceConfiguration',
      modelProperties: {
        osFamily: {
          required: true,
          serializedName: 'osFamily',
          type: {
            name: 'String'
          }
        },
        targetOSVersion: {
          required: false,
          serializedName: 'targetOSVersion',
          type: {
            name: 'String'
          }
        },
        currentOSVersion: {
          required: false,
          serializedName: 'currentOSVersion',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = CloudServiceConfiguration;
