/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ComputeNodeListResult class.
 * @constructor
 * Response to a ComputeNodeOperation.List request.
 * @member {array} [value] The list of compute nodes.
 * 
 * @member {string} [odatanextLink] The URL to get the next set of results.
 * 
 */
function ComputeNodeListResult() {
}

util.inherits(ComputeNodeListResult, Array);

/**
 * Defines the metadata of ComputeNodeListResult
 *
 * @returns {object} metadata of ComputeNodeListResult
 *
 */
ComputeNodeListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ComputeNodeListResult',
    type: {
      name: 'Composite',
      className: 'ComputeNodeListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ComputeNodeElementType',
                type: {
                  name: 'Composite',
                  className: 'ComputeNode'
                }
            }
          }
        },
        odatanextLink: {
          required: false,
          serializedName: 'odata\\.nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ComputeNodeListResult;
