/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ComputeNodeUser class.
 * @constructor
 * An user account on a compute node.
 * @member {string} name The user name of the account.
 * 
 * @member {boolean} [isAdmin] Whether the account should be an administrator
 * on the compute node.
 * 
 * @member {date} [expiryTime] The time at which the account should expire. If
 * omitted, the default is 1 day from the current time.
 * 
 * @member {string} [password] The password of the account.
 * 
 * @member {string} [sshPublicKey] The SSH public key that can be used for
 * remote login to the compute node.
 * 
 */
function ComputeNodeUser() {
}

/**
 * Defines the metadata of ComputeNodeUser
 *
 * @returns {object} metadata of ComputeNodeUser
 *
 */
ComputeNodeUser.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ComputeNodeUser',
    type: {
      name: 'Composite',
      className: 'ComputeNodeUser',
      modelProperties: {
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        isAdmin: {
          required: false,
          serializedName: 'isAdmin',
          type: {
            name: 'Boolean'
          }
        },
        expiryTime: {
          required: false,
          serializedName: 'expiryTime',
          type: {
            name: 'DateTime'
          }
        },
        password: {
          required: false,
          serializedName: 'password',
          type: {
            name: 'String'
          }
        },
        sshPublicKey: {
          required: false,
          serializedName: 'sshPublicKey',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ComputeNodeUser;
