/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the FileProperties class.
 * @constructor
 * The properties of a file on a compute node.
 * @member {date} [creationTime] The file creation time.
 * 
 * @member {date} lastModified The time at which the file was last modified.
 * 
 * @member {number} contentLength The length of the file.
 * 
 * @member {string} [contentType] The content type of the file.
 * 
 * @member {string} [fileMode] The file mode attribute in octal format. This
 * property will be returned only from a Linux compute node.
 * 
 */
function FileProperties() {
}

/**
 * Defines the metadata of FileProperties
 *
 * @returns {object} metadata of FileProperties
 *
 */
FileProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'FileProperties',
    type: {
      name: 'Composite',
      className: 'FileProperties',
      modelProperties: {
        creationTime: {
          required: false,
          serializedName: 'creationTime',
          type: {
            name: 'DateTime'
          }
        },
        lastModified: {
          required: true,
          serializedName: 'lastModified',
          type: {
            name: 'DateTime'
          }
        },
        contentLength: {
          required: true,
          serializedName: 'contentLength',
          type: {
            name: 'Number'
          }
        },
        contentType: {
          required: false,
          serializedName: 'contentType',
          type: {
            name: 'String'
          }
        },
        fileMode: {
          required: false,
          serializedName: 'fileMode',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = FileProperties;
