/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ImageReference class.
 * @constructor
 * A reference to an Azure Virtual Machines Marketplace image.
 * @member {string} publisher The publisher of the Azure Virtual Machines
 * Marketplace image. For example, Canonical or MicrosoftWindowsServer.
 * 
 * @member {string} offer The offer type of the Azure Virtual Machines
 * Marketplace image. For example, UbuntuServer or WindowsServer.
 * 
 * @member {string} sku The SKU of the Azure Virtual Machines Marketplace
 * image. For example, 14.04.0-LTS or 2012-R2-Datacenter.
 * 
 * @member {string} [version] The version of the Azure Virtual Machines
 * Marketplace image. A value of 'latest' can be specified to select the
 * latest version of an image. If omitted, the default is 'latest'.
 * 
 */
function ImageReference() {
}

/**
 * Defines the metadata of ImageReference
 *
 * @returns {object} metadata of ImageReference
 *
 */
ImageReference.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ImageReference',
    type: {
      name: 'Composite',
      className: 'ImageReference',
      modelProperties: {
        publisher: {
          required: true,
          serializedName: 'publisher',
          type: {
            name: 'String'
          }
        },
        offer: {
          required: true,
          serializedName: 'offer',
          type: {
            name: 'String'
          }
        },
        sku: {
          required: true,
          serializedName: 'sku',
          type: {
            name: 'String'
          }
        },
        version: {
          required: false,
          serializedName: 'version',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ImageReference;
