/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the JobConstraints class.
 * @constructor
 * Specifies the execution constraints for jobs created on a schedule.
 * @member {moment.duration} [maxWallClockTime] The maximum elapsed time that
 * the job may run, measured from the time the job starts. If the job does
 * not complete within the time limit, the Batch service terminates it and
 * any tasks that are still running.
 * 
 * @member {number} [maxTaskRetryCount] The maximum number of times each task
 * may be retried. The Batch service retries a task if its exit code is
 * nonzero.
 * 
 */
function JobConstraints() {
}

/**
 * Defines the metadata of JobConstraints
 *
 * @returns {object} metadata of JobConstraints
 *
 */
JobConstraints.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'JobConstraints',
    type: {
      name: 'Composite',
      className: 'JobConstraints',
      modelProperties: {
        maxWallClockTime: {
          required: false,
          serializedName: 'maxWallClockTime',
          type: {
            name: 'TimeSpan'
          }
        },
        maxTaskRetryCount: {
          required: false,
          serializedName: 'maxTaskRetryCount',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = JobConstraints;
