/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the JobScheduleExecutionInformation class.
 * @constructor
 * Specifies how tasks should be run in a job associated with a job schedule.
 * @member {date} [nextRunTime] The next time at which a job will be created
 * under this schedule.
 * 
 * @member {object} [recentJob] Information about the most recent job under
 * the job schedule.
 * 
 * @member {string} [recentJob.id] The id of the job.
 * 
 * @member {string} [recentJob.url] The URL of the job.
 * 
 * @member {date} [endTime] The time at which the schedule ended. This
 * property is set only if the job schedule is in the completed state.
 * 
 */
function JobScheduleExecutionInformation() {
}

/**
 * Defines the metadata of JobScheduleExecutionInformation
 *
 * @returns {object} metadata of JobScheduleExecutionInformation
 *
 */
JobScheduleExecutionInformation.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'JobScheduleExecutionInformation',
    type: {
      name: 'Composite',
      className: 'JobScheduleExecutionInformation',
      modelProperties: {
        nextRunTime: {
          required: false,
          serializedName: 'nextRunTime',
          type: {
            name: 'DateTime'
          }
        },
        recentJob: {
          required: false,
          serializedName: 'recentJob',
          type: {
            name: 'Composite',
            className: 'RecentJob'
          }
        },
        endTime: {
          required: false,
          serializedName: 'endTime',
          type: {
            name: 'DateTime'
          }
        }
      }
    }
  };
};

module.exports = JobScheduleExecutionInformation;
