/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the NodeDisableSchedulingParameter class.
 * @constructor
 * Parameters for a ComputeNodeOperations.DisableScheduling request.
 * @member {string} [nodeDisableSchedulingOption] What to do with currently
 * running tasks when disable task scheduling on the compute node. The
 * default value is requeue. Possible values include: 'requeue', 'terminate',
 * 'taskcompletion'
 * 
 */
function NodeDisableSchedulingParameter() {
}

/**
 * Defines the metadata of NodeDisableSchedulingParameter
 *
 * @returns {object} metadata of NodeDisableSchedulingParameter
 *
 */
NodeDisableSchedulingParameter.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'NodeDisableSchedulingParameter',
    type: {
      name: 'Composite',
      className: 'NodeDisableSchedulingParameter',
      modelProperties: {
        nodeDisableSchedulingOption: {
          required: false,
          serializedName: 'nodeDisableSchedulingOption',
          type: {
            name: 'Enum',
            allowedValues: [ 'requeue', 'terminate', 'taskcompletion' ]
          }
        }
      }
    }
  };
};

module.exports = NodeDisableSchedulingParameter;
