/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the NodeReimageParameter class.
 * @constructor
 * Parameters for a ComputeNodeOperations.Reimage request.
 * @member {string} [nodeReimageOption] When to reimage the compute node and
 * what to do with currently running tasks. The default value is requeue.
 * Possible values include: 'requeue', 'terminate', 'taskcompletion',
 * 'retaineddata'
 * 
 */
function NodeReimageParameter() {
}

/**
 * Defines the metadata of NodeReimageParameter
 *
 * @returns {object} metadata of NodeReimageParameter
 *
 */
NodeReimageParameter.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'NodeReimageParameter',
    type: {
      name: 'Composite',
      className: 'NodeReimageParameter',
      modelProperties: {
        nodeReimageOption: {
          required: false,
          serializedName: 'nodeReimageOption',
          type: {
            name: 'Enum',
            allowedValues: [ 'requeue', 'terminate', 'taskcompletion', 'retaineddata' ]
          }
        }
      }
    }
  };
};

module.exports = NodeReimageParameter;
