/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the NodeRemoveParameter class.
 * @constructor
 * Parameters for a ComputeNodeOperations.Remove request.
 * @member {array} nodeList A list containing the id of the compute nodes to
 * be removed from the specified pool.
 * 
 * @member {moment.duration} [resizeTimeout] The timeout for removal of
 * compute nodes to the pool. The default value is 10 minutes.
 * 
 * @member {string} [nodeDeallocationOption] When compute nodes may be removed
 * from the pool. Possible values include: 'requeue', 'terminate',
 * 'taskcompletion', 'retaineddata'
 * 
 */
function NodeRemoveParameter() {
}

/**
 * Defines the metadata of NodeRemoveParameter
 *
 * @returns {object} metadata of NodeRemoveParameter
 *
 */
NodeRemoveParameter.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'NodeRemoveParameter',
    type: {
      name: 'Composite',
      className: 'NodeRemoveParameter',
      modelProperties: {
        nodeList: {
          required: true,
          serializedName: 'nodeList',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        resizeTimeout: {
          required: false,
          serializedName: 'resizeTimeout',
          type: {
            name: 'TimeSpan'
          }
        },
        nodeDeallocationOption: {
          required: false,
          serializedName: 'nodeDeallocationOption',
          type: {
            name: 'Enum',
            allowedValues: [ 'requeue', 'terminate', 'taskcompletion', 'retaineddata' ]
          }
        }
      }
    }
  };
};

module.exports = NodeRemoveParameter;
