/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the PoolStopResizeOptions class.
 * @constructor
 * Additional parameters for the stopResize operation.
 * @member {number} [timeout] The maximum time that the server can spend
 * processing the request, in seconds. The default is 30 seconds. Default
 * value: 30 .
 * 
 * @member {string} [clientRequestId] The caller-generated request identity,
 * in the form of a GUID with no decoration such as curly braces, e.g.
 * 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0.
 * 
 * @member {boolean} [returnClientRequestId] Whether the server should return
 * the client-request-id identifier in the response.
 * 
 * @member {date} [ocpDate] The time the request was issued. If not specified,
 * this header will be automatically populated with the current system clock
 * time.
 * 
 * @member {string} [ifMatch] An ETag is specified. Specify this header to
 * perform the operation only if the resource's ETag is an exact match as
 * specified.
 * 
 * @member {string} [ifNoneMatch] An ETag is specified. Specify this header to
 * perform the operation only if the resource's ETag does not match the
 * specified ETag.
 * 
 * @member {date} [ifModifiedSince] Specify this header to perform the
 * operation only if the resource has been modified since the specified
 * date/time.
 * 
 * @member {date} [ifUnmodifiedSince] Specify this header to perform the
 * operation only if the resource has not been modified since the specified
 * date/time.
 * 
 */
function PoolStopResizeOptions() {
}

/**
 * Defines the metadata of PoolStopResizeOptions
 *
 * @returns {object} metadata of PoolStopResizeOptions
 *
 */
PoolStopResizeOptions.prototype.mapper = function () {
  return {
    required: false,
    type: {
      name: 'Composite',
      className: 'PoolStopResizeOptions',
      modelProperties: {
        timeout: {
          required: false,
          defaultValue: 30,
          type: {
            name: 'Number'
          }
        },
        clientRequestId: {
          required: false,
          type: {
            name: 'String'
          }
        },
        returnClientRequestId: {
          required: false,
          type: {
            name: 'Boolean'
          }
        },
        ocpDate: {
          required: false,
          type: {
            name: 'DateTimeRfc1123'
          }
        },
        ifMatch: {
          required: false,
          type: {
            name: 'String'
          }
        },
        ifNoneMatch: {
          required: false,
          type: {
            name: 'String'
          }
        },
        ifModifiedSince: {
          required: false,
          type: {
            name: 'DateTimeRfc1123'
          }
        },
        ifUnmodifiedSince: {
          required: false,
          type: {
            name: 'DateTimeRfc1123'
          }
        }
      }
    }
  };
};

module.exports = PoolStopResizeOptions;
