/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ResourceFile class.
 * @constructor
 * A file to be downloaded from Azure blob storage to a compute node.
 * @member {string} [blobSource] The URL of the file within Azure Blob
 * Storage. This URL should include a shared access signature if the blob is
 * not publicly readable.
 * 
 * @member {string} [filePath] The location to which to download the file,
 * relative to the task's working directory.
 * 
 * @member {string} [fileMode] The file mode attribute in octal format. This
 * property will be ignored if it is specified for a resourceFile which will
 * be downloaded to a Windows compute node.
 * 
 */
function ResourceFile() {
}

/**
 * Defines the metadata of ResourceFile
 *
 * @returns {object} metadata of ResourceFile
 *
 */
ResourceFile.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ResourceFile',
    type: {
      name: 'Composite',
      className: 'ResourceFile',
      modelProperties: {
        blobSource: {
          required: false,
          serializedName: 'blobSource',
          type: {
            name: 'String'
          }
        },
        filePath: {
          required: false,
          serializedName: 'filePath',
          type: {
            name: 'String'
          }
        },
        fileMode: {
          required: false,
          serializedName: 'fileMode',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ResourceFile;
