/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the TaskIdRange class.
 * @constructor
 * A range of task ids that a task can depend on. All tasks with ids in the
 * range must complete successfully before the dependent task can be
 * scheduled.
 * @member {number} start The first task id in the range.
 * 
 * @member {number} end The last task id in the range.
 * 
 */
function TaskIdRange() {
}

/**
 * Defines the metadata of TaskIdRange
 *
 * @returns {object} metadata of TaskIdRange
 *
 */
TaskIdRange.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TaskIdRange',
    type: {
      name: 'Composite',
      className: 'TaskIdRange',
      modelProperties: {
        start: {
          required: true,
          serializedName: 'start',
          type: {
            name: 'Number'
          }
        },
        end: {
          required: true,
          serializedName: 'end',
          type: {
            name: 'Number'
          }
        }
      }
    }
  };
};

module.exports = TaskIdRange;
