/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the TaskSchedulingPolicy class.
 * @constructor
 * Specifies how tasks should be distributed across compute nodes.
 * @member {string} nodeFillType How tasks should be distributed across
 * compute nodes. Possible values include: 'spread', 'pack', 'unmapped'
 * 
 */
function TaskSchedulingPolicy() {
}

/**
 * Defines the metadata of TaskSchedulingPolicy
 *
 * @returns {object} metadata of TaskSchedulingPolicy
 *
 */
TaskSchedulingPolicy.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TaskSchedulingPolicy',
    type: {
      name: 'Composite',
      className: 'TaskSchedulingPolicy',
      modelProperties: {
        nodeFillType: {
          required: true,
          serializedName: 'nodeFillType',
          type: {
            name: 'Enum',
            allowedValues: [ 'spread', 'pack', 'unmapped' ]
          }
        }
      }
    }
  };
};

module.exports = TaskSchedulingPolicy;
