/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the TaskUpdateParameter class.
 * @constructor
 * Parameters for a CloudTaskOperations.Update request.
 * @member {object} [constraints] Constraints that apply to this task. If
 * omitted, the task is given the default constraints.
 * 
 * @member {moment.duration} [constraints.maxWallClockTime] The maximum
 * elapsed time that the task may run, measured from the time the task
 * starts. If the task does not complete within the time limit, the Batch
 * service terminates it.
 * 
 * @member {moment.duration} [constraints.retentionTime] The minimum time to
 * retain the working directory for the task on the compute node where it
 * ran, from the time it completes execution. After this time, the Batch
 * service may delete the working directory and all its contents. The default
 * is infinite.
 * 
 * @member {number} [constraints.maxTaskRetryCount] The maximum number of
 * times the task may be retried. The Batch service retries a task if its
 * exit code is nonzero.
 * 
 */
function TaskUpdateParameter() {
}

/**
 * Defines the metadata of TaskUpdateParameter
 *
 * @returns {object} metadata of TaskUpdateParameter
 *
 */
TaskUpdateParameter.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TaskUpdateParameter',
    type: {
      name: 'Composite',
      className: 'TaskUpdateParameter',
      modelProperties: {
        constraints: {
          required: false,
          serializedName: 'constraints',
          type: {
            name: 'Composite',
            className: 'TaskConstraints'
          }
        }
      }
    }
  };
};

module.exports = TaskUpdateParameter;
