/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the AADObject class.
 * @constructor
 * Active Directory object information
 * @member {string} [objectId] Gets or sets object Id
 * 
 * @member {string} [objectType] Gets or sets object type
 * 
 * @member {string} [displayName] Gets or sets object display name
 * 
 * @member {string} [userPrincipalName] Gets or sets principal name
 * 
 * @member {string} [mail] Gets or sets mail
 * 
 * @member {boolean} [mailEnabled] Gets or sets MailEnabled field
 * 
 * @member {boolean} [securityEnabled] Gets or sets SecurityEnabled field
 * 
 * @member {string} [signInName] Gets or sets signIn name
 * 
 * @member {array} [servicePrincipalNames] Gets or sets the list of service
 * principal names.
 * 
 * @member {string} [userType] Gets or sets the user type
 * 
 */
function AADObject() {
}

/**
 * Defines the metadata of AADObject
 *
 * @returns {object} metadata of AADObject
 *
 */
AADObject.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'AADObject',
    type: {
      name: 'Composite',
      className: 'AADObject',
      modelProperties: {
        objectId: {
          required: false,
          serializedName: 'objectId',
          type: {
            name: 'String'
          }
        },
        objectType: {
          required: false,
          serializedName: 'objectType',
          type: {
            name: 'String'
          }
        },
        displayName: {
          required: false,
          serializedName: 'displayName',
          type: {
            name: 'String'
          }
        },
        userPrincipalName: {
          required: false,
          serializedName: 'userPrincipalName',
          type: {
            name: 'String'
          }
        },
        mail: {
          required: false,
          serializedName: 'mail',
          type: {
            name: 'String'
          }
        },
        mailEnabled: {
          required: false,
          serializedName: 'mailEnabled',
          type: {
            name: 'Boolean'
          }
        },
        securityEnabled: {
          required: false,
          serializedName: 'securityEnabled',
          type: {
            name: 'Boolean'
          }
        },
        signInName: {
          required: false,
          serializedName: 'signInName',
          type: {
            name: 'String'
          }
        },
        servicePrincipalNames: {
          required: false,
          serializedName: 'servicePrincipalNames',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        userType: {
          required: false,
          serializedName: 'userType',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = AADObject;
