/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the ADGroup class.
 * @constructor
 * Active Directory group information
 * @member {string} [objectId] Gets or sets object Id
 * 
 * @member {string} [objectType] Gets or sets object type
 * 
 * @member {string} [displayName] Gets or sets group display name
 * 
 * @member {boolean} [securityEnabled] Gets or sets security enabled field
 * 
 * @member {string} [mail] Gets or sets mail field
 * 
 */
function ADGroup() {
}

/**
 * Defines the metadata of ADGroup
 *
 * @returns {object} metadata of ADGroup
 *
 */
ADGroup.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ADGroup',
    type: {
      name: 'Composite',
      className: 'ADGroup',
      modelProperties: {
        objectId: {
          required: false,
          serializedName: 'objectId',
          type: {
            name: 'String'
          }
        },
        objectType: {
          required: false,
          serializedName: 'objectType',
          type: {
            name: 'String'
          }
        },
        displayName: {
          required: false,
          serializedName: 'displayName',
          type: {
            name: 'String'
          }
        },
        securityEnabled: {
          required: false,
          serializedName: 'securityEnabled',
          type: {
            name: 'Boolean'
          }
        },
        mail: {
          required: false,
          serializedName: 'mail',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ADGroup;
