/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ApplicationUpdateParameters class.
 * @constructor
 * Request parameters for updating an existing application
 * @member {string} [displayName] Application display name
 * 
 * @member {string} [homepage] Application homepage
 * 
 * @member {array} [identifierUris] Application Uris
 * 
 * @member {array} [replyUrls] Application reply Urls
 * 
 * @member {array} [keyCredentials] Gets or sets the list of KeyCredential
 * objects
 * 
 * @member {array} [passwordCredentials] Gets or sets the list of
 * PasswordCredential objects
 * 
 */
function ApplicationUpdateParameters() {
}

/**
 * Defines the metadata of ApplicationUpdateParameters
 *
 * @returns {object} metadata of ApplicationUpdateParameters
 *
 */
ApplicationUpdateParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ApplicationUpdateParameters',
    type: {
      name: 'Composite',
      className: 'ApplicationUpdateParameters',
      modelProperties: {
        displayName: {
          required: false,
          serializedName: 'displayName',
          type: {
            name: 'String'
          }
        },
        homepage: {
          required: false,
          serializedName: 'homepage',
          type: {
            name: 'String'
          }
        },
        identifierUris: {
          required: false,
          serializedName: 'identifierUris',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        replyUrls: {
          required: false,
          serializedName: 'replyUrls',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        keyCredentials: {
          required: false,
          serializedName: 'keyCredentials',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'KeyCredentialElementType',
                type: {
                  name: 'Composite',
                  className: 'KeyCredential'
                }
            }
          }
        },
        passwordCredentials: {
          required: false,
          serializedName: 'passwordCredentials',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'PasswordCredentialElementType',
                type: {
                  name: 'Composite',
                  className: 'PasswordCredential'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = ApplicationUpdateParameters;
