/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the GetObjectsParameters class.
 * @constructor
 * Request parameters for GetObjectsByObjectIds API call
 * @member {array} [objectIds] Requested object Ids
 * 
 * @member {array} [types] Requested object types
 * 
 * @member {boolean} includeDirectoryObjectReferences If true, also searches
 * for object ids in the partner tenant
 * 
 */
function GetObjectsParameters() {
}

/**
 * Defines the metadata of GetObjectsParameters
 *
 * @returns {object} metadata of GetObjectsParameters
 *
 */
GetObjectsParameters.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'GetObjectsParameters',
    type: {
      name: 'Composite',
      className: 'GetObjectsParameters',
      modelProperties: {
        objectIds: {
          required: false,
          serializedName: 'objectIds',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        types: {
          required: false,
          serializedName: 'types',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        includeDirectoryObjectReferences: {
          required: true,
          serializedName: 'includeDirectoryObjectReferences',
          type: {
            name: 'Boolean'
          }
        }
      }
    }
  };
};

module.exports = GetObjectsParameters;
