/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the KeyCredential class.
 * @constructor
 * Active Directory service principal Key Credential information
 * @member {date} [startDate] Gets or sets start date
 * 
 * @member {date} [endDate] Gets or sets end date
 * 
 * @member {string} [value] Gets or sets value
 * 
 * @member {string} [keyId] Gets or sets key Id
 * 
 * @member {string} [usage] Gets or sets usage
 * 
 * @member {string} [type] Gets or sets type
 * 
 */
function KeyCredential() {
}

/**
 * Defines the metadata of KeyCredential
 *
 * @returns {object} metadata of KeyCredential
 *
 */
KeyCredential.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'KeyCredential',
    type: {
      name: 'Composite',
      className: 'KeyCredential',
      modelProperties: {
        startDate: {
          required: false,
          serializedName: 'startDate',
          type: {
            name: 'DateTime'
          }
        },
        endDate: {
          required: false,
          serializedName: 'endDate',
          type: {
            name: 'DateTime'
          }
        },
        value: {
          required: false,
          serializedName: 'value',
          type: {
            name: 'String'
          }
        },
        keyId: {
          required: false,
          serializedName: 'keyId',
          type: {
            name: 'String'
          }
        },
        usage: {
          required: false,
          serializedName: 'usage',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = KeyCredential;
