/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the PasswordCredential class.
 * @constructor
 * Active Directory service principal Password Credential information
 * @member {date} [startDate] Gets or sets start date
 * 
 * @member {date} [endDate] Gets or sets end date
 * 
 * @member {string} [keyId] Gets or sets key Id
 * 
 * @member {string} [value] Gets or sets value
 * 
 */
function PasswordCredential() {
}

/**
 * Defines the metadata of PasswordCredential
 *
 * @returns {object} metadata of PasswordCredential
 *
 */
PasswordCredential.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'PasswordCredential',
    type: {
      name: 'Composite',
      className: 'PasswordCredential',
      modelProperties: {
        startDate: {
          required: false,
          serializedName: 'startDate',
          type: {
            name: 'DateTime'
          }
        },
        endDate: {
          required: false,
          serializedName: 'endDate',
          type: {
            name: 'DateTime'
          }
        },
        keyId: {
          required: false,
          serializedName: 'keyId',
          type: {
            name: 'String'
          }
        },
        value: {
          required: false,
          serializedName: 'value',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = PasswordCredential;
