/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ServicePrincipalListResult class.
 * @constructor
 * Server response for get tenant service principals API call
 * @member {array} [value] Gets or sets the list of service principals.
 * 
 * @member {string} [odatanextLink] Gets or sets the URL to get the next set
 * of results.
 * 
 */
function ServicePrincipalListResult() {
}

util.inherits(ServicePrincipalListResult, Array);

/**
 * Defines the metadata of ServicePrincipalListResult
 *
 * @returns {object} metadata of ServicePrincipalListResult
 *
 */
ServicePrincipalListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ServicePrincipalListResult',
    type: {
      name: 'Composite',
      className: 'ServicePrincipalListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ServicePrincipalElementType',
                type: {
                  name: 'Composite',
                  className: 'ServicePrincipal'
                }
            }
          }
        },
        odatanextLink: {
          required: false,
          serializedName: 'odata\\.nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ServicePrincipalListResult;
