/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the User class.
 * @constructor
 * Active Directory user information
 * @member {string} [objectId] Gets or sets object Id
 * 
 * @member {string} [objectType] Gets or sets object type
 * 
 * @member {string} [userPrincipalName] Gets or sets user principal name
 * 
 * @member {string} [displayName] Gets or sets user display name
 * 
 * @member {string} [signInName] Gets or sets user signIn name
 * 
 * @member {string} [mail] Gets or sets user mail
 * 
 * @member {string} [mailNickname] The mail alias for the user
 * 
 */
function User() {
}

/**
 * Defines the metadata of User
 *
 * @returns {object} metadata of User
 *
 */
User.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'User',
    type: {
      name: 'Composite',
      className: 'User',
      modelProperties: {
        objectId: {
          required: false,
          serializedName: 'objectId',
          type: {
            name: 'String'
          }
        },
        objectType: {
          required: false,
          serializedName: 'objectType',
          type: {
            name: 'String'
          }
        },
        userPrincipalName: {
          required: false,
          serializedName: 'userPrincipalName',
          type: {
            name: 'String'
          }
        },
        displayName: {
          required: false,
          serializedName: 'displayName',
          type: {
            name: 'String'
          }
        },
        signInName: {
          required: false,
          serializedName: 'signInName',
          type: {
            name: 'String'
          }
        },
        mail: {
          required: false,
          serializedName: 'mail',
          type: {
            name: 'String'
          }
        },
        mailNickname: {
          required: false,
          serializedName: 'mailNickname',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = User;
