/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the UserListResult class.
 * @constructor
 * Server response for Get tenant users API call
 * @member {array} [value] Gets or sets the list of users.
 * 
 * @member {string} [odatanextLink] Gets or sets the URL to get the next set
 * of results.
 * 
 */
function UserListResult() {
}

util.inherits(UserListResult, Array);

/**
 * Defines the metadata of UserListResult
 *
 * @returns {object} metadata of UserListResult
 *
 */
UserListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'UserListResult',
    type: {
      name: 'Composite',
      className: 'UserListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'UserElementType',
                type: {
                  name: 'Composite',
                  className: 'User'
                }
            }
          }
        },
        odatanextLink: {
          required: false,
          serializedName: 'odata\\.nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = UserListResult;
