/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the DeploymentExtended class.
 * @constructor
 * Deployment information.
 * @member {string} [id] Gets or sets the ID of the deployment.
 * 
 * @member {string} name Gets or sets the name of the deployment.
 * 
 * @member {object} [properties] Gets or sets deployment properties.
 * 
 * @member {string} [properties.provisioningState] Gets or sets the state of
 * the provisioning.
 * 
 * @member {string} [properties.correlationId] Gets or sets the correlation ID
 * of the deployment.
 * 
 * @member {date} [properties.timestamp] Gets or sets the timestamp of the
 * template deployment.
 * 
 * @member {object} [properties.outputs] Gets or sets key/value pairs that
 * represent deploymentoutput.
 * 
 * @member {array} [properties.providers] Gets the list of resource providers
 * needed for the deployment.
 * 
 * @member {array} [properties.dependencies] Gets the list of deployment
 * dependencies.
 * 
 * @member {object} [properties.template] Gets or sets the template content.
 * Use only one of Template or TemplateLink.
 * 
 * @member {object} [properties.templateLink] Gets or sets the URI referencing
 * the template. Use only one of Template or TemplateLink.
 * 
 * @member {string} [properties.templateLink.uri] URI referencing the template.
 * 
 * @member {string} [properties.templateLink.contentVersion] If included it
 * must match the ContentVersion in the template.
 * 
 * @member {object} [properties.parameters] Deployment parameters. Use only
 * one of Parameters or ParametersLink.
 * 
 * @member {object} [properties.parametersLink] Gets or sets the URI
 * referencing the parameters. Use only one of Parameters or ParametersLink.
 * 
 * @member {string} [properties.parametersLink.uri] URI referencing the
 * template.
 * 
 * @member {string} [properties.parametersLink.contentVersion] If included it
 * must match the ContentVersion in the template.
 * 
 * @member {string} [properties.mode] Gets or sets the deployment mode.
 * Possible values include: 'Incremental', 'Complete'
 * 
 * @member {object} [properties.debugSetting] Gets or sets the debug setting
 * of the deployment.
 * 
 * @member {string} [properties.debugSetting.detailLevel] Gets or sets the
 * debug detail level.
 * 
 */
function DeploymentExtended() {
}

/**
 * Defines the metadata of DeploymentExtended
 *
 * @returns {object} metadata of DeploymentExtended
 *
 */
DeploymentExtended.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DeploymentExtended',
    type: {
      name: 'Composite',
      className: 'DeploymentExtended',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'DeploymentPropertiesExtended'
          }
        }
      }
    }
  };
};

module.exports = DeploymentExtended;
