/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the DeploymentOperation class.
 * @constructor
 * Deployment operation information.
 * @member {string} [id] Gets or sets full deployment operation id.
 * 
 * @member {string} [operationId] Gets or sets deployment operation id.
 * 
 * @member {object} [properties] Gets or sets deployment properties.
 * 
 * @member {string} [properties.provisioningState] Gets or sets the state of
 * the provisioning.
 * 
 * @member {date} [properties.timestamp] Gets or sets the date and time of the
 * operation.
 * 
 * @member {string} [properties.serviceRequestId] Gets or sets deployment
 * operation service request id.
 * 
 * @member {string} [properties.statusCode] Gets or sets operation status code.
 * 
 * @member {object} [properties.statusMessage] Gets or sets operation status
 * message.
 * 
 * @member {object} [properties.targetResource] Gets or sets the target
 * resource.
 * 
 * @member {string} [properties.targetResource.id] Gets or sets the ID of the
 * resource.
 * 
 * @member {string} [properties.targetResource.resourceName] Gets or sets the
 * name of the resource.
 * 
 * @member {string} [properties.targetResource.resourceType] Gets or sets the
 * type of the resource.
 * 
 * @member {object} [properties.request] Gets or sets the HTTP request message.
 * 
 * @member {object} [properties.request.content] Gets or sets HTTP message
 * content.
 * 
 * @member {object} [properties.response] Gets or sets the HTTP response
 * message.
 * 
 * @member {object} [properties.response.content] Gets or sets HTTP message
 * content.
 * 
 */
function DeploymentOperation() {
}

/**
 * Defines the metadata of DeploymentOperation
 *
 * @returns {object} metadata of DeploymentOperation
 *
 */
DeploymentOperation.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DeploymentOperation',
    type: {
      name: 'Composite',
      className: 'DeploymentOperation',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        operationId: {
          required: false,
          serializedName: 'operationId',
          type: {
            name: 'String'
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'DeploymentOperationProperties'
          }
        }
      }
    }
  };
};

module.exports = DeploymentOperation;
