/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the DeploymentOperationProperties class.
 * @constructor
 * Deployment operation properties.
 * @member {string} [provisioningState] Gets or sets the state of the
 * provisioning.
 * 
 * @member {date} [timestamp] Gets or sets the date and time of the operation.
 * 
 * @member {string} [serviceRequestId] Gets or sets deployment operation
 * service request id.
 * 
 * @member {string} [statusCode] Gets or sets operation status code.
 * 
 * @member {object} [statusMessage] Gets or sets operation status message.
 * 
 * @member {object} [targetResource] Gets or sets the target resource.
 * 
 * @member {string} [targetResource.id] Gets or sets the ID of the resource.
 * 
 * @member {string} [targetResource.resourceName] Gets or sets the name of the
 * resource.
 * 
 * @member {string} [targetResource.resourceType] Gets or sets the type of the
 * resource.
 * 
 * @member {object} [request] Gets or sets the HTTP request message.
 * 
 * @member {object} [request.content] Gets or sets HTTP message content.
 * 
 * @member {object} [response] Gets or sets the HTTP response message.
 * 
 * @member {object} [response.content] Gets or sets HTTP message content.
 * 
 */
function DeploymentOperationProperties() {
}

/**
 * Defines the metadata of DeploymentOperationProperties
 *
 * @returns {object} metadata of DeploymentOperationProperties
 *
 */
DeploymentOperationProperties.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'DeploymentOperationProperties',
    type: {
      name: 'Composite',
      className: 'DeploymentOperationProperties',
      modelProperties: {
        provisioningState: {
          required: false,
          serializedName: 'provisioningState',
          type: {
            name: 'String'
          }
        },
        timestamp: {
          required: false,
          serializedName: 'timestamp',
          type: {
            name: 'DateTime'
          }
        },
        serviceRequestId: {
          required: false,
          serializedName: 'serviceRequestId',
          type: {
            name: 'String'
          }
        },
        statusCode: {
          required: false,
          serializedName: 'statusCode',
          type: {
            name: 'String'
          }
        },
        statusMessage: {
          required: false,
          serializedName: 'statusMessage',
          type: {
            name: 'Object'
          }
        },
        targetResource: {
          required: false,
          serializedName: 'targetResource',
          type: {
            name: 'Composite',
            className: 'TargetResource'
          }
        },
        request: {
          required: false,
          serializedName: 'request',
          type: {
            name: 'Composite',
            className: 'HttpMessage'
          }
        },
        response: {
          required: false,
          serializedName: 'response',
          type: {
            name: 'Composite',
            className: 'HttpMessage'
          }
        }
      }
    }
  };
};

module.exports = DeploymentOperationProperties;
