/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ExportTemplateRequest class.
 * @constructor
 * Export resource group template request parameters.
 * @member {array} [resources] Gets or sets the ids of the resources. The only
 * supported string currently is '*' (all resources). Future api updates will
 * support exporting specific resources.
 * 
 * @member {string} [options] The export template options. Supported values
 * include 'IncludeParameterDefaultValue', 'IncludeComments' or
 * 'IncludeParameterDefaultValue, IncludeComments
 * 
 */
function ExportTemplateRequest() {
}

/**
 * Defines the metadata of ExportTemplateRequest
 *
 * @returns {object} metadata of ExportTemplateRequest
 *
 */
ExportTemplateRequest.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ExportTemplateRequest',
    type: {
      name: 'Composite',
      className: 'ExportTemplateRequest',
      modelProperties: {
        resources: {
          required: false,
          serializedName: 'resources',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        options: {
          required: false,
          serializedName: 'options',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ExportTemplateRequest;
