/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the PolicyDefinition class.
 * @constructor
 * Policy definition.
 * @member {object} [properties] Gets or sets the policy definition properties.
 * 
 * @member {string} [properties.description] Gets or sets the policy
 * definition description.
 * 
 * @member {string} [properties.displayName] Gets or sets the policy
 * definition display name.
 * 
 * @member {object} [properties.policyRule] The policy rule json.
 * 
 * @member {string} [name] Gets or sets the policy definition name.
 * 
 */
function PolicyDefinition() {
}

/**
 * Defines the metadata of PolicyDefinition
 *
 * @returns {object} metadata of PolicyDefinition
 *
 */
PolicyDefinition.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'PolicyDefinition',
    type: {
      name: 'Composite',
      className: 'PolicyDefinition',
      modelProperties: {
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Composite',
            className: 'PolicyDefinitionProperties'
          }
        },
        name: {
          required: false,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = PolicyDefinition;
