/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ProviderResourceType class.
 * @constructor
 * Resource type managed by the resource provider.
 * @member {string} [resourceType] Gets or sets the resource type.
 * 
 * @member {array} [locations] Gets or sets the collection of locations where
 * this resource type can be created in.
 * 
 * @member {array} [apiVersions] Gets or sets the api version.
 * 
 * @member {object} [properties] Gets or sets the properties.
 * 
 */
function ProviderResourceType() {
}

/**
 * Defines the metadata of ProviderResourceType
 *
 * @returns {object} metadata of ProviderResourceType
 *
 */
ProviderResourceType.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ProviderResourceType',
    type: {
      name: 'Composite',
      className: 'ProviderResourceType',
      modelProperties: {
        resourceType: {
          required: false,
          serializedName: 'resourceType',
          type: {
            name: 'String'
          }
        },
        locations: {
          required: false,
          serializedName: 'locations',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        apiVersions: {
          required: false,
          serializedName: 'apiVersions',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        properties: {
          required: false,
          serializedName: 'properties',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = ProviderResourceType;
