/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ResourceGroupListResult class.
 * @constructor
 * List of resource groups.
 * @member {array} [value] Gets or sets the list of resource groups.
 * 
 * @member {string} nextLink Gets or sets the URL to get the next set of
 * results.
 * 
 */
function ResourceGroupListResult() {
}

util.inherits(ResourceGroupListResult, Array);

/**
 * Defines the metadata of ResourceGroupListResult
 *
 * @returns {object} metadata of ResourceGroupListResult
 *
 */
ResourceGroupListResult.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'ResourceGroupListResult',
    type: {
      name: 'Composite',
      className: 'ResourceGroupListResult',
      modelProperties: {
        value: {
          required: false,
          serializedName: '',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'ResourceGroupElementType',
                type: {
                  name: 'Composite',
                  className: 'ResourceGroup'
                }
            }
          }
        },
        nextLink: {
          required: true,
          serializedName: 'nextLink',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = ResourceGroupListResult;
