/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the TagDetails class.
 * @constructor
 * Tag details.
 * @member {string} [id] Gets or sets the tag ID.
 * 
 * @member {string} [tagName] Gets or sets the tag name.
 * 
 * @member {object} [count] Gets or sets the tag count.
 * 
 * @member {string} [count.type] Type of count.
 * 
 * @member {string} [count.value] Value of count.
 * 
 * @member {array} [values] Gets or sets the list of tag values.
 * 
 */
function TagDetails() {
}

/**
 * Defines the metadata of TagDetails
 *
 * @returns {object} metadata of TagDetails
 *
 */
TagDetails.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'TagDetails',
    type: {
      name: 'Composite',
      className: 'TagDetails',
      modelProperties: {
        id: {
          required: false,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        tagName: {
          required: false,
          serializedName: 'tagName',
          type: {
            name: 'String'
          }
        },
        count: {
          required: false,
          serializedName: 'count',
          type: {
            name: 'Composite',
            className: 'TagCount'
          }
        },
        values: {
          required: false,
          serializedName: 'values',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'TagValueElementType',
                type: {
                  name: 'Composite',
                  className: 'TagValue'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = TagDetails;
